BLOCK NAMES{}
C Groups.
C 1=W and Higgs propagators, three and four vertices.
C 2=Ghost propagators and vertices.
C 3=quark propagators and vertices.
C 4=Lepton propagators and vertices.

C It is important with respect to ordering that m is mentioned last.
C Sofar only one generation was needed. The neutrino mass is kept finite.

A N,N_,Pi,C,S
A PM,M,M0,Mu,Md,Me,Mn
C Mc,Ms,Mm,Mt,Mb,Mv
A m

F Ax,Bx,Cx,Dx,Fx,Log,VE4,VE3,PROP

C L1,... Internal Lorentz indices (Dimension N).
  l1,... Gamma matrix indices.
  c1,... color indices.

I L1=N,l1,c1=3,L2=N,l2,c2=3,L3=N,l3,c3=3,
  L4=N,l4,c4=3,L5=N,l5,c5=3,L6=N,l6,c6=3,
  L7=N,l7,c7=3,L8=N,l8,c8=3,L9=N,l9,c9=3

C al,be,ga,de,mu,nu   External Lorents indices (Dimension 4).
  lA,lB,lC,lD         External gamma indices.
  cA,cB,cC,cD         External color indices.

I al,be,ga,de,mu,nu
I lA,lB,lC,lD
I cA=3,cB=3,cC=3,cD=3

C P,Q,K,Q1,... Internal momenta.
  p0,p,q,k,... External momenta, specifically p0(mu) = p0(2) = p0Dp0 = 0.

V p0=z,q,p,k,P,Q,K,Q1
ENDBLOCK

BLOCK VERT{}

C A=Photon, F=Neutral Higgs ghost, G=Positive Higgs Ghost,
  U=Positive W, W=Neutral W, Z=HIGGS.

  F-P ghosts: C stands for Chi, P for Plus, M for Minus.
  Y=CP, P=CM, R=Y0, T=YA.

  Fermions:
  u=Up, d=Down, e=Electron, 1=Electron-neutrino.
  c=Charm, s=Strange, m=Muon, 2=Muon neutrino.
  t=Top, b=Bottom, v=Tau, 3=Tau neutrino,

X DEDEX(L1,L2,L3,L4)=2.*D(L1,L2)*D(L3,L4) - D(L1,L3)*D(L2,L4)
                                         - D(L1,L4)*D(L2,L3)

T TAP: A,F,W,Z
T TFE: P,R,T,Y, u,d,1,e, c,s,2,m, t,b,3,v
T THI: Z=1:1

Anti,TAP

G 1

C Vector bosons.

X AA(L1,l1,c1,L2,l2,c2,K) = NOM(K,PM)*D(L1,L2)
X U_U(L1,l1,c1,L2,l2,c2,K) = NOM(K,M)*D(L1,L2)
X WW(L1,l1,c1,L2,l2,c2,K) = NOM(K,M0)*D(L1,L2)

X FF(L1,l1,c1,L2,l2,c2,K) = NOM(K,M0)
X G_G(L1,l1,c1,L2,l2,c2,K) = NOM(K,M)
X ZZ(L1,l1,c1,L2,l2,c2,K) = NOM(K,m)

X AG_G(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = S*K(L1)-S*Q(L1)
X AU_U(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -S*D(L1,L3)*(K(L2)-P(L2))
       -S*D(L1,L2)*(P(L3)-Q(L3))-S*D(L2,L3)*(Q(L1)-K(L1))
X FGU_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*Q(L3)+0.5*P(L3)
X FG_U(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*Q(L3)-0.5*P(L3)
X FWZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i*(P(L2)-K(L2))/2/C
X G_GW(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = [C^2-S^2]*(Q(L3)-P(L3))/2/C
X GU_Z(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*i*(P(L2)-K(L2))
X G_UZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*i*(P(L2)-K(L2))
X U_UW(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -C*D(L1,L2)*(P(L3)-Q(L3))
   -C*D(L2,L3)*(Q(L1)-K(L1))-C*D(L1,L3)*(K(L2)-P(L2))

X AGU_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - i*S*M*D(L1,L3)
X AG_U(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i*S*M*D(L1,L3)
X FFZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - 0.5*m**2/M
X G_GZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*m**2/M
X GU_W(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i*S**2*M*D(L2,L3)/C
X G_UW(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - i*S**2*M*D(L2,L3)/C
X U_UZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - M*D(L1,L2)
X WWZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -M*D(L1,L2)/C**2
X ZZZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -1.5*m**2/M

X AAG_G(L1,L2,L3,L4) = - 2.*S**2*D(L1,L2)
X AAU_U(L1,L2,L3,L4) = - S**2*DEDEX(L1,L2,L3,L4)
X AFGU_(L1,L2,L3,L4) = 0.5*S*D(L1,L4)
X AFG_U(L1,L2,L3,L4) = 0.5*S*D(L1,L4)
X AG_GW(L1,L2,L3,L4) = - S*[C^2-S^2]*D(L1,L4)/C
X AGU_Z(L1,L2,L3,L4) = - 0.5*i*S*D(L1,L3)
X AG_UZ(L1,L2,L3,L4) = 0.5*i*S*D(L1,L3)
X AU_UW(L1,L2,L3,L4) = - S*C*DEDEX(L1,L4,L2,L3)
X FFFF(L1,L2,L3,L4) = - 0.75*m**2/M**2
X FFG_G(L1,L2,L3,L4) = - 0.25*m**2/M**2
X FFU_U(L1,L2,L3,L4) = - 0.5*D(L3,L4)
X FFWW(L1,L2,L3,L4) = - 0.5*D(L3,L4)/C**2
X FFZZ(L1,L2,L3,L4) = - 0.25*m**2/M**2
X FGU_W(L1,L2,L3,L4) = - 0.5*S**2*D(L3,L4)/C
X FG_UW(L1,L2,L3,L4) = - 0.5*S**2*D(L3,L4)/C
X G_G_GG(L1,L2,L3,L4) = - 0.5*m**2/M**2
X G_GU_U(L1,L2,L3,L4) = - 0.5*D(L3,L4)
X G_GWW(L1,L2,L3,L4) = - 0.5*[C^2-S^2]**2*D(L3,L4)/C**2
X G_GZZ(L1,L2,L3,L4) = - 0.25*m**2/M**2
X GU_WZ(L1,L2,L3,L4) = 0.5*i*S**2*D(L2,L3)/C
X G_UWZ(L1,L2,L3,L4) = - 0.5*i*S**2*D(L2,L3)/C
X U_U_UU(L1,L2,L3,L4) = DEDEX(L1,L2,L3,L4)
X U_UWW(L1,L2,L3,L4) = - C**2*DEDEX(L2,L1,L4,L3)
X U_UZZ(L1,L2,L3,L4) = - 0.5*D(L1,L2)
X WWZZ(L1,L2,L3,L4) = - 0.5*D(L1,L2)/C**2
X ZZZZ(L1,L2,L3,L4) = - 0.75*m**2/M**2

G 2

C F-P ghosts.

X P_P(L1,l1,c1,L2,l2,c2,K) = NOM(K,M)
X R_R(L1,l1,c1,L2,l2,c2,K) = NOM(K,M0)
X T_T(L1,l1,c1,L2,l2,c2,K) = NOM(K,PM)
X Y_Y(L1,l1,c1,L2,l2,c2,K) = NOM(K,M)

X AP_P(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = S*Q(L1)
X AY_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - S*Q(L1)
X P_PW(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = C*P(L3)
X P_RU_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -C*P(L3)
X P_TU_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -S*P(L3)
X PR_U(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - C*Q(L3)
X PT_U(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -S*Q(L3)
X R_U_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = C*P(L2)
X RUY_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = C*K(L2)
X T_U_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = S*P(L2)
X TUY_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = S*K(L2)
X WY_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -C*Q(L1)

X FP_P(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*i*M
X FY_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*i*M
X GPR_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*i*M*C**-1
X GRY_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*i*[C^2-S^2]*M/C
X GTY_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -i*S*M
X G_P_R(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = 0.5*i*[C^2-S^2]*M/C
X G_P_T(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i*S*M
X G_R_Y(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*i*M*C**-1
X P_PZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*M
X R_RZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*M/C**2
X Y_YZ(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = -0.5*M

G 3
C Quarks.

X u_u(L1,l1,c1,L2,l2,c2,K)= - i*NOM(K,Mu)*G(l1,l2,K)*D(c1,c2)
  + NOM(K,Mu)*Gi(l1,l2)*Mu*D(c1,c2)
X d_d(L1,l1,c1,L2,l2,c2,K)= - i*NOM(K,Md)*G(l1,l2,K)*D(c1,c2)
  + NOM(K,Md)*Gi(l1,l2)*Md*D(c1,c2)

X Udu_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/2/Sqrt2*G(l3,l2,L1,G6)*D(c2,c3)
X U_d_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/2/Sqrt2*G(l2,l3,L1,G6)*D(c2,c3)
X Wu_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)=i/4/C*[1-8/3*S^2]*G(l2,l3,L1)*D(c2,c3)
				 + i/4/C*G(l2,l3,L1,G5)*D(c2,c3)
X Wd_d(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)=i/4/C*[4/3*S^2-1]*G(l2,l3,L1)*D(c2,c3)
				 - i/4/C*G(l2,l3,L1,G5)*D(c2,c3)
X Au_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= 2/3*i*S*G(l2,l3,L1)*D(c2,c3)
X Ad_d(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= - 1/3*i*S*G(l2,l3,L1)

X Gdu_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) =
 - i/2/Sqrt2*Md/M*G(l3,l2,Gi)*D(c2,c3) + i/2/Sqrt2*Md/M*G(l3,l2,G5)*D(c2,c3)
 + i/2/Sqrt2*Mu/M*G(l3,l2,Gi)*D(c2,c3) + i/2/Sqrt2*Mu/M*G(l3,l2,G5)*D(c2,c3)
X G_d_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) =
 + i/2/Sqrt2*Md/M*G(l2,l3,Gi)*D(c2,c3) + i/2/Sqrt2*Md/M*G(l2,l3,G5)*D(c2,c3)
 - i/2/Sqrt2*Mu/M*G(l2,l3,Gi)*D(c2,c3) + i/2/Sqrt2*Mu/M*G(l2,l3,G5)*D(c2,c3)
X Zu_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - 1/2*Mu/M*G(l2,l3,Gi)*D(c2,c3)
X Zd_d(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - 1/2*Md/M*G(l2,l3,Gi)*D(c2,c3)
X Fu_u(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i/2*Mu/M*G(l2,l3,G5)*D(c2,c3)
X Fd_d(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - i/2*Md/M*G(l2,l3,G5)*D(c2,c3)

G 4
C Leptons.

X 1_1(L1,l1,c1,L2,l2,c2,K)= -i*NOM(K,Mn)*G(l1,l2,K) + NOM(K,Mn)*Gi(l1,l2)*Mn
X e_e(L1,l1,c1,L2,l2,c2,K)= -i*NOM(K,Me)*G(l1,l2,K) + NOM(K,Me)*Gi(l1,l2)*Me

X Ue1_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/2/Sqrt2*G(l3,l2,L1,G6)
X U_e_1(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/2/Sqrt2*G(l2,l3,L1,G6)
X W1_1(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/4/C*G(l2,l3,L1,G6)
X We_e(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= i/4/C*[4*S^2-1]*G(l2,l3,L1)
				 - i/4/C*G(l2,l3,L1,G5)
X Ae_e(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K)= - i*S*G(l2,l3,L1)

X Ge1_(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) =
 - i/2/Sqrt2*Me/M*G(l3,l2,Gi) + i/2/Sqrt2*Me/M*G(l3,l2,G5)
 + i/2/Sqrt2*Mn/M*G(l3,l2,Gi) + i/2/Sqrt2*Mn/M*G(l3,l2,G5)
X G_e_1(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) =
 + i/2/Sqrt2*Me/M*G(l2,l3,Gi) + i/2/Sqrt2*Me/M*G(l2,l3,G5)
 - i/2/Sqrt2*Mn/M*G(l2,l3,Gi) + i/2/Sqrt2*Mn/M*G(l2,l3,G5)
X Z1_1(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - 1/2*Mn/M*G(l2,l3,Gi)
X Ze_e(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - 1/2*Me/M*G(l2,l3,Gi)
X F1_1(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = i/2*Mn/M*G(l2,l3,G5)
X Fe_e(L1,l1,c1,P,L2,l2,c2,Q,L3,l3,c3,K) = - i/2*Me/M*G(l2,l3,G5)

G

ENDBLOCK

End
