C
C Two-loop large Higgs mass correction to the ro-parameter.
C J.van der Bij and M. Veltman, Nucl. Phys. B231 (1984) 205.
C
C RO-parameter 1.  Divergencies of one-loop diagrams, two external lines.
C RO-parameter 2.  Divergencies of one-loop diagrams, three external lines.
C RO-parameter 3.  Divergencies of one-loop diagrams, four external lines.
C RO-parameter 4.  Divergencies of one-loop diagrams, ghost external lines.
C RO-parameter 5.  Two-loop self-energy diagrams.
C RO-parameter 6.  One-loop subtractions. RO-parameter result.
C RO-parameter 7.  Two-loop self-energy diagrams. A-A wave-function.
C RO-parameter 8.  Two-loop self-energy diagrams. A-W wave-function.
C RO-parameter 9.  Subtractions for A-A and A-W wave-functions.
C RO-parameter 10. Tadpoles in A-A wave-function.
C RO-parameter 11. Diagrams with tadpole insertions.
C RO-parameter 12. Counter-term Lagrangian for the standard model.
C RO-parameter 13. Counter terms for the Ghost Lagrangian, standard model.
C RO-parameter 14. Rationalization.
C RO-parameter 15. Epsilon expansion and projection operators.
C RO-parameter 16. Differentiating F111.
C RO-parameter 17. Differentiating F211.
C RO-parameter 18. Expansion of F211(SM,M1,M2) for large SM.
C RO-parameter 19. Higher orders of F211(M,M0,SM) expansion for large SM.
C RO-parameter 20. Expansion of F211(SM,SM,M) for large SM.
*end

C RO-parameter 1. Divergencies of one-loop diagrams, two external lines.

C ONE-LOOP DIAGRAMS WITH TWO EXTERNAL LINES.
C CALCULATION OF ONE-LOOP DIVERGENCIES.
C CHECKING OF COUNTERTERMS ALSO DONE.

C Running time (CPU only) on Lansing CDC: 27 sec.
C The new character sum techniques give about a factor 2 improvement.

Oldnew i=I
P ninp
Read Roblocks.e
C P input
VERT{,,,,}
X NUM(K1,K2)=1.-2.*DT(K1-9)*DT(K2-9)
*fix
P ninput
BLOCK WORK{TADP}
P ninput
Id,SELF(I1~,I2~)=
   DS(I1;J1;J2;Sym;J1;J2;TAP,1,(DIB(I1,J1,-J1,J2,-J2,I2)
  *DC("F,TFE,-1,J1,J2) ))
 + DS(I1;J3;-J3;I2;Sym;J3,-J3;TAP,2,(DIC(I1,J3,-J3,I2) ))
    +CONTR(I1,I2)*DLP/EP

Id,Anti,TAP
Id,DIB(I1~,K1~,K2~,K3~,K4~,I2~)=
   VE3(I1,K1,K3,*,MU,Q,*,L1,-K,*,L3,P)*
   VE3(K2,I2,K4,*,L2,K,*,NU,-Q,*,L4,-P)*
   PROP(K1,K2,*,L1,K,*,L2,K)*
   PROP(K3,K4,*,L3,P,*,L4,P)
Id,DIC(I1~,K1~,K2~,I2~)=
   VE4(I1,K1,K2,I2,*,MU,*,L1,*,L2,*,NU)*
   PROP(K1,K2,*,L1,P,*,L2,P)
B EP,I,PI2,DEL,TIPI2
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,NOM(P,M~)*NOM(K,M0~)=F2(M,M0)
Al,NOM(P,M~)=F1(M)
Id,P(MU~)*F1(M~)=0.
*yep
Id,2,K(MU~)=P(MU)+Q(MU)
Al,PDQ*F2(M~,M0~)=QDQ*B1(M,M0)
Al,PDK*F2(M~,M0~)=PDP*F2(M,M0)+QDQ*B1(M,M0)
Al,QDK*F2(M~,M0~)=QDQ*F2(M,M0)+QDQ*B1(M,M0)
Id,PDP*F2(M~,M0~)=F1(M0)-M**2*F2(M,M0)
Al,KDK*F2(M~,M0~)=F1(M)-M0**2*F2(M,M0)
Id,P(MU~)*P(NU~)*F2(M~,M0~)=D(MU,NU)*B22(M,M0)
          +Q(MU)*Q(NU)*B21(M,M0)
Id,P(MU~)*F2(M~,M0~)=Q(MU)*B1(M,M0)
*yep
Id,B22(M~,M0~)=(-0.5*F1(M0)+M**2*F2(M,M0)
      -0.5*(QDQ+M0**2-M**2)*B1(M,M0))/OMN
Id,B21(M~,M0~)=-((0.5*N-1)*F1(M0)
       -0.5*N*(QDQ+M0**2-M**2)*B1(M,M0)
       +M**2*F2(M,M0) )/QDQ/OMN
Id,B1(M~,M0~)=(0.5*F1(M)-0.5*F1(M0)
              -0.5*(QDQ+M0**2-M**2)*F2(M,M0) )/QDQ
Id,F1(PM)=0.
Al,PM=0.
Al,Multi,M0**2=M**2/C**2
Al,C2MS2=2*C**2-1
Id,Multi,S**2=1.-C**2
*yep
Id,F1(M~)=TIPI2*M**2/EP-0.5*TIPI2*M**2*(1.-LG(M))
  +0.5*EP*TIPI2*M**2*(PI2/24+0.5-0.5*LG(M)+0.25*LG(M)*LG(M))
Al,N*OMN**-1=-4/3+EP/9-EP**2/27
Al,N=4.+EP
Al,OMN**-1=-1/3+EP/9-EP**2/27
Al,Symme,F2,1,2
Id,ZTAG*F2(SM,SM)=-0.5*TIPI2*(PI/W3-2)*(QDQ+SM**2)/SM**2
   -TIPI2/EP - 0.5*TIPI2*(LG(SM)-2+PI/W3)
Al,ZTAG*F2(M~,M~)=0.5*TIPI2*(LG(SM)-LG(M)-2)*(QDQ+SM**2)/SM**2
   -TIPI2/EP-0.5*TIPI2*(LG(SM)-2)
Id,F2(M~,M~)=-TIPI2/EP-0.5*TIPI2*LG(M)+QDQ*BB0(M,M)/M**2
   -0.5*TIPI2*EP*(PI2/24+0.25*LG(M)*LG(M))
   +EP*QDQ*BB0E(M,M)/M**2
Al,F2(M~,SM)=-TIPI2/EP+0.5*TIPI2*(1.-LG(SM)
  +M**2*LG(M,SM)/SM**2-0.5*QDQ/SM**2)
  +TIPI2*EP*(-0.25-PI2/48+0.25*LG(SM)-LG(SM)*LG(SM)/8
  +1/SM**2*(3*QDQ/16-QDQ*LG(SM)/8-M**2/4*LG(M,SM)
  +M**2/8*LG(M)*LG(M)-M**2/8*LG(SM)*LG(SM)))
Al,F2(M~,M0~)=-TIPI2/EP+0.5*TIPI2-0.5*TIPI2*LG(M0)
    -0.5*TIPI2*M**2*DIF(M,M0)*LG(M,M0)+QDQ*BB0(M,M0)/M0**2
  +EP*BB0E(M,M0)
Id,Multi,EP**2=0
Al,PM=0
Al,Multi,M0**2=M**2/C**2
Al,ZTAG=1
Id,EP**-1=ATEL9**10*DEL/TIPI2
Al,F1F(SM)=F1F(SM)*ATEL9**2
Id,Count,1,ATEL9,1,SM,1,CONTR,4,ET,2
Id,ATEL9=1.
Id,LG(M,S~)=LG(M)-LG(S)
Al,LG(M0,S~)=LG(M0)-LG(S)
Al,LG(SM,S~)=LG(SM)-LG(S)
Id,DIF(PM,M~)=-1./M**2
Al,DIF(M,M0)=-C**2/M**2/S**2
Id,Multi,C**2=1.-S**2
Id,Multi,S**2=1.-C**2
*yep
SVERT{,~,~}
Id,CONTR(I1~,I2~)=CONT(I1,I2,"N,*,MU,Q,*,NU,-Q,*,AL,P0)
Id,Compo,<X>,CONT
Id,CONT(AA~,MU~,P0~,L2~,Q~,L1~,P~)=AA(MU,P0,L2,Q,L1,P)
E1EZF{,,,,}
Id,EP**-1=DEL/TIPI2
Al,C2MS2=2*C**2-1
Id,Multi,S**2=1-C**2
Id,EP*DEL=TIPI2
Al,EP**2*DEL=TIPI2*EP
P output
*yep
Id,DLP=-1
*next
P input
ENDBLOCK
Z TADP=DS(J1,1,16,(0.5*NUM(J1,J1)*
   DIB("Z,CHG(J1),CHH(J1) ) ))
   -M*SM**2*ET*DLP/EP
Id,DIB(K1~,K2~,K3~)=
   VE3(K1,K2,K3,*,L1,P0,*,L2,-P,*,L3,P)*
   PROP(K2,K3,*,L2,P,*,L3,P)
   *ATEL9**10
WORK{TADP}
Z IAA=SELF("A,"A)
WORK{IAA}
Z IAF=SELF("A,"F)
WORK{IAF}
Z IAW=SELF("A,"W)
WORK{IAW}
Z IAZ=SELF("A,"Z)
WORK{IAZ}
Z IFF=SELF("F,"F)
WORK{IFF}
Z IFW=SELF("F,"W)
WORK{IFW}
Z IFZ=SELF("F,"Z)
WORK{IFZ}
Z IGH=SELF("G,"G_)
WORK{IGH}
Z IGV=SELF("G,"U_)
WORK{IGV}
Z IHU=SELF("G_,"U)
WORK{IHU}
Z IUV=SELF("U,"U_)
WORK{IUV}
Z IWW=SELF("W,"W)
WORK{IWW}
Z IWZ=SELF("W,"Z)
WORK{IWZ}
Z IZZ=SELF("Z,"Z)*ZTAG
C SET QDQ=-SM**2 TO FIND THAT MASS RENORMALIZATION OK.
C NO COUNTER-TERMS PROPORTIONAL TO EP HAVE BEEN INTRODUCED.
C SUCH TERMS HAVE ALSO BEEN NEGLECTED IN THE CALCULATION.
WORK{IZZ}
Z IOP=SELF("P_,"P)
WORK{IOP}
Z IQR=SELF("R_,"R)
WORK{IQR}
Z IQT=SELF("R_,"T)
WORK{IQT}
Z IRS=SELF("R,"T_)
WORK{IRS}
Z IST=SELF("T_,"T)
WORK{IST}
Z IXY=SELF("Y_,"Y)
WORK{IXY}
*end

C RO-parameter 2. Divergencies of one-loop diagrams, three external lines.

C ONE-LOOP DIAGRAMS WITH THREE EXTERNAL LINES.
C CALCULATION OF ONE-LOOP DIVERGENCIES.
C COUNTER-TERMS ARE CHECKED.
C CDC CPU time: 35.2 sec.

Oldnew i=I
P ninput
Read Roblocks.e
C P input
VERT{,,,,}
V R,T,U,V
X HUM(K1,K2)=1.-0.5*DK(K1,K2)
*fix
P ninput
BLOCK WORK{TADP}
P ninput
Id,VERT(K1~,K2~,K3~)=
  DS(K1;J1;-J2;TAP,(DS(K2;-J1;J3;TAP,(
  DIB(K1,K2,K3,J1,-J1,J3,-J3,J2,-J2)*DC("F,TFE,-1,J1,J2) ))))
 +DS(K1;K2;J4;-J5;Sym;J4;-J5;TAP,(VIR1(K1,K2,K3,J4,-J4,-J5,J5) ))
 +DS(K2;K3;J6;-J7;Sym;J6;-J7;TAP,(VIR2(K1,K2,K3,J6,-J6,-J7,J7) ))
 +DS(K1;K3;J8;-J9;Sym;J8;-J9;TAP,(VIR3(K1,K2,K3,J8,-J8,-J9,J9) ))

    +CONTR(K1,K2,K3)

Id,Anti,TAP

Id,DIB(K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~)=
   VE3(K1,K4,K9,*,MU,Q,*,L4,P,*,L9,-R)*
   VE3(K2,K5,K6,*,NU,T,*,L5,-P,*,L6,V)*
   VE3(K3,K7,K8,*,AL,K,*,L7,-V,*,L8,R)*
   PROP(K4,K5,*,L4,P,*,L5,P)*
   PROP(K6,K7,*,L6,V,*,L7,V)*
   PROP(K8,K9,*,L8,R,*,L9,R)
Al,VIR1(K1~,K2~,K3~,K4~,K5~,K6~,K7~)=
   VE4(K1,K2,K4,K6,*,MU,*,NU,*,L4,*,L6)*
   VE3(K3,K5,K7,*,AL,K,*,L5,P,*,L7,-U)*
  PROP(K6,K7,*,L6,U,*,L7,U)*PROP(K4,K5,*,L4,P,*,L5,P)
Al,VIR2(K1~,K2~,K3~,K4~,K5~,K6~,K7~)=
   VE4(K2,K3,K4,K6,*,NU,*,AL,*,L4,*,L6)*
   VE3(K1,K5,K7,*,MU,Q,*,L5,P,*,L7,-R)*
  PROP(K6,K7,*,L6,R,*,L7,R)*PROP(K4,K5,*,L4,P,*,L5,P)
Al,VIR3(K1~,K2~,K3~,K4~,K5~,K6~,K7~)=
   VE4(K1,K3,K4,K6,*,MU,*,AL,*,L5,*,L7)*
   VE3(K2,K5,K7,*,NU,T,*,L4,-P,*,L6,V)*
  PROP(K4,K5,*,L4,P,*,L5,P)*PROP(K6,K7,*,L6,V,*,L7,V)
B EP,I,TIPI2
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,P0(MU~)=0.
Al,Dotpr,P0(MU~)=0.
Id,Commu,NOM
Id,NOM(P,M~)*NOM(R,M0~)*NOM(V,SM~)=1.
Al,NOM(P,M~)*NOM(Q~,M0~)=F2(Q)
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
*yep
Id,R(MU~)=P(MU)+Q(MU)
Id,V(MU~)=P(MU)+Q(MU)+K(MU)
Id,U(MU~)=P(MU)+K(MU)
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
Id,RDR=PDP+2.*PDQ
Al,VDV=PDP-2.*PDT
Al,PDR=PDP+PDQ
Al,PDV=PDP-PDT
Al,VDR=PDP+2.*PDQ+PDK-QDT
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
Id,VDK=PDK
Al,VDT=PDT
Al,VDQ=PDQ
Al,RDK=PDK
Al,RDT=PDT
Al,RDQ=PDQ
Al,N=4
Al,C2MS2=2.*C**2-1
*yep
Id,P(MU~)*P(NU~)*P(AL~)=D3(MU,NU,AL,Q)*DEL*TIPI2/EP/6.
     +D3(MU,NU,AL,K)*DEL*TIPI2/EP/12.
Id,P(MU~)*PDP=Q(MU)*DEL*TIPI2/EP+K(MU)*DEL*TIPI2/EP/2.
Al,PDP=-DEL*TIPI2/EP
Id,P(MU~)*P(NU~)=-0.25*D(MU,NU)*DEL*TIPI2/EP
Id,P(MU~)*PDK=-0.25*K(MU)*DEL*TIPI2/EP
Id,P(MU~)*PDQ=-0.25*Q(MU)*DEL*TIPI2/EP
Id,P(MU~)*PDT=-0.25*DEL*TIPI2/EP*T(MU)
Id,P(MU~)*F2(R)=0.5*DEL*TIPI2/EP*Q(MU)
Id,P(MU~)*F2(U)=0.5*DEL*TIPI2/EP*K(MU)
Id,P(MU~)*F2(V)=0.5*DEL*TIPI2/EP*(Q(MU)+K(MU))
Id,F2(Q~)=-DEL*TIPI2/EP
*yep
Id,T(MU~)=-K(MU)-Q(MU)
Al,TDT=QDQ+KDK+2.*QDK
Id,Dotpr,T(MU~)=-K(MU)-Q(MU)
Id,D3(MU~,NU~,AL~,Q~)=D(MU,NU)*Q(AL)+D(MU,AL)*Q(NU)+D(NU,AL)*Q(MU)
Id,Multi,S**2=1.-C**2
Keep 'TADP'
Nprint 'TADP'
*next
SVERT{~,,~}
Z 'TADP'='TADP'(AL,P,BE,Q,GA,K)
Id,CONTR(K1~,K2~,K3~)=CONT(K1,K2,K3,/,"K)*
    VE3(K1,K2,K3,*,AL,P,*,BE,Q,*,GA,K)/EP
Id,Compo,<SS>,CONT,<X>,VE3
Id,CONT(S~)=S
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=AA(MU,P0,L2,Q,L1,P)
*yep
CVERT{,~,~}
SCVERT{,~,~}
Id,C2MS2=2*C**2-1
*yep
E1EZF{,,~,~,~}
Id,Count,1,EP,-2,E1F,-2,EZF,-2
B EP,I,TIPI2
Id,Multi,S**2=1-C**2
Al,Q(MU~)=-P(MU)-K(MU)
P output
*yep
Id,DEL=-1.
*next
P input
ENDBLOCK
P input
Z IUVW(MU,Q,NU,T,AL,K)=VERT("U,"U_,"W)
WORK{IUVW}
Z IAUV(MU,Q,NU,T,AL,K)=VERT("A,"U,"U_)
WORK{IAUV}
Z IUVZ(MU,Q,NU,T,AL,K)=VERT("U,"U_,"Z)
WORK{IUVZ}
Z IFHU(MU,Q,NU,T,AL,K)=VERT("F,"G_,"U)
WORK{IFHU}
Z IAHU(MU,Q,NU,T,AL,K)=VERT("A,"G_,"U)
WORK{IAHU}
Z IFFZ(MU,Q,NU,T,AL,K)=VERT("F,"F,"Z)
WORK{IFFZ}
Z IZZZ(MU,Q,NU,T,AL,K)=VERT("Z,"Z,"Z)
WORK{IZZZ}
Z IAGH(MU,Q,NU,T,AL,K)=VERT("A,"G,"G_)
WORK{IAGH}
Z IAGV(MU,Q,NU,T,AL,K)=VERT("A,"G,"U_)
WORK{IAGV}
Z IFGV(MU,Q,NU,T,AL,K)=VERT("F,"G,"U_)
WORK{IFGV}
Z IFWZ(MU,Q,NU,T,AL,K)=VERT("F,"W,"Z)
WORK{IFWZ}
Z IGHZ(MU,Q,NU,T,AL,K)=VERT("G,"G_,"Z)
WORK{IGHZ}
Z IGHW(MU,Q,NU,T,AL,K)=VERT("G,"G_,"W)
WORK{IGHW}
Z IGVW(MU,Q,NU,T,AL,K)=VERT("G,"U_,"W)
WORK{IGVW}
Z IGVZ(MU,Q,NU,T,AL,K)=VERT("G,"U_,"Z)
WORK{IGVZ}
Z IHUW(MU,Q,NU,T,AL,K)=VERT("G_,"U,"W)
WORK{IHUW}
Z IHUZ(MU,Q,NU,T,AL,K)=VERT("G_,"U,"Z)
WORK{IHUZ}
Z IWWZ(MU,Q,NU,T,AL,K)=VERT("W,"W,"Z)
WORK{IWWZ}
Z IAFZ(MU,Q,NU,T,AL,K)=VERT("A,"F,"Z)
WORK{IAFZ}
Z IAWZ(MU,Q,NU,T,AL,K)=VERT("A,"W,"Z)
WORK{IAWZ}
*end

C RO-parameter 3. Divergencies of one-loop diagrams, four external lines.

C ONE-LOOP DIAGRAMS WITH FOUR EXTERNAL LINES.
C CALCULATION OF ONE-LOOP DIVERGENCIES.
C COMPARISON WITH COUTERTERMS INCLUDED.
C CDC CPU time: 178.37 sec.

Oldnew i=I
P ninput
Read Roblocks.e
VERT{,~,,,~}
I LA=N,LB=N
X HUM(K1,K2)=1.-0.5*DK(K1,K2)
*fix
P ninput
BLOCK WORK{TADP}
P ninput
Id,VIERP(K1~,K2~,K3~,K4~)=
   VIER(K1,K2,K3,K4,L1,L2,L3,L4) +
   VIER(K1,K3,K2,K4,L1,L3,L2,L4) +
   VIER(K1,K2,K4,K3,L1,L2,L4,L3)
    +CONTR(K1,K2,K3,K4)

Id,VIER(K1~,K2~,K3~,K4~,L1~,L2~,L3~,L4~)=
  DS(K1;J1;-J2;TAP,(
    DS(K2;J2;-J3;TAP,(
      DS(K3;J3;-J4;TAP,(
    VIE(K1,K2,K3,K4,L1,L2,L3,L4,J1,-J2,J2,-J3,J3,-J4,J4,-J1)
     * DC("F,TFE,-1,J1,J2) ))) )))

   + DS(K1;K3;J5;-J6;TAP,(
       DS(K4;J6;-J7;TAP,(
    VIE1(K1,K2,K3,K4,L1,L2,L3,L4,J5,-J6,J6,-J7,J7,-J5) )) ))

   + DS(K2;K4;J8;-J9;TAP,(
       DS(K1;J9;-J0;TAP,(
     VIE2(K1,K2,K3,K4,L1,L2,L3,L4,J8,-J9,J9,-J0,J0,-J8) )) ))

   + DS(K1;K3;JA;-JB;Sym;JA;-JB;TAP,(
     VIE3(K1,K2,K3,K4,L1,L2,L3,L4,JA,-JB,JB,-JA) ) )

Id,Anti,TAP

Id,VIE(K1~,K2~,K3~,K4~,L1~,L2~,L3~,L4~,K5~,K6~,K7~,K8~,K9~,K0~,
    KA~,KB~)=
   VE3(K1,K5,K6,*,L1,P0,*,L5,P,*,L6,-P)*
   VE3(K2,K7,K8,*,L2,P0,*,L70,P,*,L8,-P)*
   VE3(K3,K9,K0,*,L3,P0,*,L9,P,*,L0,-P)*
   VE3(K4,KA,KB,*,L4,P0,*,LA,P,*,LB,-P)*
   PR8*D(L6,L70)*D(L8,L9)*D(L0,LA)*D(LB,L5)
Al,VIE1(K1~,K2~,K3~,K4~,L1~,L2~,L3~,L4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE4(K1,K3,K5,K6,*,L1,*,L3,*,L5,*,L6)*
   VE3(K4,K7,K8,*,L4,P0,*,L71,P,*,L8,-P)*
   VE3(K2,K9,K0,*,L2,P0,*,L9,P,*,L0,-P)*
   PR6*D(L0,L5)*D(L6,L71)*D(L8,L9)
Al,VIE2(K1~,K2~,K3~,K4~,L1~,L2~,L3~,L4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE4(K2,K4,K5,K6,*,L2,*,L4,*,L5,*,L6)*
   VE3(K1,K7,K8,*,L1,P0,*,L72,P,*,L8,-P)*
   VE3(K3,K9,K0,*,L3,P0,*,L9,P,*,L0,-P)*
   PR6*D(L0,L5)*D(L6,L72)*D(L8,L9)
Al,VIE3(K1~,K2~,K3~,K4~,L1~,L2~,L3~,L4~,K5~,K6~,K7~,K8~)=
   VE4(K2,K4,K7,K8,*,L2,*,L4,*,L73,*,L8)*
   VE4(K1,K3,K5,K6,*,L1,*,L3,*,L5,*,L6)*
   PR4*D(L5,L8)*D(L6,L73)
Id,Stats
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,Stats,1
C AL,PROP(AA+,L4+,Q+,L3+,P+)=AA(L4,L3,Q)
Id,Count,-4,P,1,PR8,-8,PR6,-6,PR4,-4
Id,PR8*PDP**2=-DEL*TIPI2/EP
Al,PR6*PDP=-DEL*TIPI2/EP
Al,PR4=-DEL*TIPI2/EP
Id,PR8*PDP*P(MU~)*P(NU~)=-0.25*DEL*TIPI2/EP*D(MU,NU)
Al,PR6*P(MU~)*P(NU~)=-0.25*DEL*TIPI2/EP*D(MU,NU)
Id,PR8*P(MU~)*P(NU~)*P(AL~)*P(BE~)=-DEL*TIPI2/EP/24*D4(MU,NU,AL,BE)
Id,Symme,D4,1,2,3,4
Al,N=4
Al,PR8=0
B EP,TIPI2
*yep
Id,D4(L1~,L2~,L3~,L4~)=D(L1,L2)*D(L3,L4)+D(L1,L3)*D(L2,L4)
                      +D(L1,L4)*D(L2,L3)
Al,C2MS2=2*C**2-1
Al,Multi,S**2=1-C**2
Keep 'TADP'
Nprint 'TADP'
*next
SVERT{~,~,}
Z 'TADP'='TADP'
Id,CONTR(K1~,K2~,K3~,K4~)=CONT(K1,K2,K3,K4,/,"K)*
       VE4(K1,K2,K3,K4,*,L1,*,L2,*,L3,*,L4)/EP
Id,Compo,<SS>,CONT,<X>,VE4
Id,CONT(S~)=S
Al,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
B EP,TIPI2
*yep
CVERT{~,,~}
SCVERT{~,,~}
*yep
Id,C2MS2=2*C**2-1
E1EZF{,,~,~,~}
Id,Count,1,EP,-2,EZF,-2,E1F,-2
Id,Multi,S**2=1-C**2
P output
*yep
P input
Id,DEL=-1.
*next
ENDBLOCK
Z IAAUV=VIERP("A,"A,"U,"U_)
WORK{IAAUV}
Z IAFGV=VIERP("A,"F,"G,"U_)
WORK{IAFGV}
Z IAFHU=VIERP("A,"F,"G_,"U)
WORK{IAFHU}
Z IAGHW=VIERP("A,"G,"G_,"W)
WORK{IAGHW}
Z IAGVZ=VIERP("A,"G,"U_,"Z)
WORK{IAGVZ}
Z IAHUZ=VIERP("A,"G_,"U,"Z)
WORK{IAHUZ}
Z IAUVW=VIERP("A,"U,"U_,"W)
WORK{IAUVW}
Z IAAGH=VIERP("A,"A,"G,"G_)
WORK{IAAGH}
Z IAAUV=VIERP("A,"A,"U,"U_)
WORK{IAAUV}
Z IFGVW=VIERP("F,"G,"U_,"W)
WORK{IFGVW}
Z IFHUW=VIERP("F,"G_,"U,"W)
WORK{IFHUW}
Z IFFGH=VIERP("F,"F,"G,"G_)
WORK{IFFGH}
Z IFFUV=VIERP("F,"F,"U,"U_)
WORK{IFFUV}
Z IFFWW=VIERP("F,"F,"W,"W)
WORK{IFFWW}
Z IFFZZ=VIERP("F,"F,"Z,"Z)
WORK{IFFZZ}
Z IFFFF=VIERP("F,"F,"F,"F)
WORK{IFFFF}
Z IGHUV=VIERP("G,"G_,"U,"U_)
WORK{IGHUV}
Z IGHWW=VIERP("G,"G_,"W,"W)
WORK{IGHWW}
Z IGHZZ=VIERP("G,"G_,"Z,"Z)
WORK{IGHZZ}
Z IGVWZ=VIERP("G,"U_,"W,"Z)
WORK{IGVWZ}
Z IGGHH=VIERP("G,"G,"G_,"G_)
WORK{IGGHH}
Z IHUWZ=VIERP("G_,"U,"W,"Z)
WORK{IHUWZ}
Z IUUVV=VIERP("U,"U,"U_,"U_)
WORK{IUUVV}
Z IUVZZ=VIERP("U,"U_,"Z,"Z)
WORK{IUVZZ}
Z IUVWW=VIERP("U,"U_,"W,"W)
WORK{IUVWW}
Z IWWZZ=VIERP("W,"W,"Z,"Z)
WORK{IWWZZ}
Z IZZZZ=VIERP("Z,"Z,"Z,"Z)
WORK{IZZZZ}
Z IAFFW=VIERP("A,"F,"F,"W)
WORK{IAFFW}
Z IAWZZ=VIERP("A,"W,"Z,"Z)
WORK{IAWZZ}
*end

C RO-parameter 4. Divergencies of one-loop diagrams, ghost external lines.

C ONE-LOOP THREE-POINT DIAGRAMS WITH EXTERNAL GHOST LINES.
C CALCULATION OF ONE-LOOP DIVERGENCIES.
C COUNTERTERMS ARE ALSO CHECKED.
C CDC CPU time: 16.09 sec.

Oldnew i=I
P ninput
Read Roblocks.e
VERT{,,~,,}
V R,T,U,V
*fix
P ninput
BLOCK WORK{TADP}
P ninput
Id,VERT(K1~,K2~,K3~)=
  DS(K1;J1;-J2;TAP,(DS(K2;-J1;J3;TAP,(
  DIB(K1,K2,K3,J1,-J1,J3,-J3,J2,-J2)  ))))
    + CONTR(K1,K2,K3)

Id,Anti,TAP

Id,DIB(K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~)=
   VE3(K1,K4,K9,*,MU,Q,*,L4,P,*,L9,-R)*
   VE3(K2,K5,K6,*,NU,T,*,L5,-P,*,L6,V)*
   VE3(K3,K7,K8,*,AL,K,*,L7,-V,*,L8,R)*
   PROP(K4,K5,*,L4,P,*,L5,P)*
   PROP(K6,K7,*,L6,V,*,L7,V)*
   PROP(K8,K9,*,L8,R,*,L9,R)
B EP,TIPI2
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,P0(MU~)=0.
Al,Dotpr,P0(MU~)=0.
Id,Commu,NOM
Id,NOM(P,M~)*NOM(R,M0~)*NOM(V,SM~)=1.
Al,NOM(P,M~)*NOM(Q~,M0~)=F2(Q)
Al,NOM(P,M~)=F1(M)
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
*yep
Id,R(MU~)=P(MU)+Q(MU)
Id,V(MU~)=P(MU)+Q(MU)+K(MU)
Id,U(MU~)=P(MU)+K(MU)
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
Id,RDR=PDP+2.*PDQ
Al,VDV=PDP-2.*PDT
Al,PDR=PDP+PDQ
Al,PDV=PDP-PDT
Al,VDR=PDP+2.*PDQ+PDK-QDT
Id,Count,3,P,2,R,2,V,2,F2,4,CONTR,4
Id,VDK=PDK
Al,VDT=PDT
Al,VDQ=PDQ
Al,RDK=PDK
Al,RDT=PDT
Al,RDQ=PDQ
Al,N=4
Al,C2MS2=2*C**2-1
*yep
Id,P(MU~)*P(NU~)*P(AL~)=D3(MU,NU,AL,Q)*DEL*TIPI2/EP/6.
     +D3(MU,NU,AL,K)*DEL*TIPI2/EP/12.
Id,P(MU~)*PDP=Q(MU)*DEL*TIPI2/EP+K(MU)*DEL*TIPI2/EP/2.
Al,PDP=-DEL*TIPI2/EP
Id,P(MU~)*P(NU~)=-0.25*D(MU,NU)*DEL*TIPI2/EP
Id,P(MU~)*PDK=-0.25*K(MU)*DEL*TIPI2/EP
Id,P(MU~)*PDQ=-0.25*Q(MU)*DEL*TIPI2/EP
Id,P(MU~)*PDT=-0.25*DEL*TIPI2/EP*T(MU)
Id,P(MU~)*F2(R)=0.5*DEL*TIPI2/EP*Q(MU)
Id,P(MU~)*F2(U)=0.5*DEL*TIPI2/EP*K(MU)
Id,P(MU~)*F2(V)=0.5*DEL*TIPI2/EP*(Q(MU)+K(MU))
Id,F2(Q~)=-DEL*TIPI2/EP
*yep
Id,T(MU~)=-K(MU)-Q(MU)
Al,TDT=QDQ+KDK+2.*QDK
Id,Dotpr,T(MU~)=-K(MU)-Q(MU)
Id,D3(MU~,NU~,AL~,Q~)=D(MU,NU)*Q(AL)+D(MU,AL)*Q(NU)+D(NU,AL)*Q(MU)
Id,Multi,S**2=1.-C**2
Keep 'TADP'
Nprint 'TADP'
*next
SVERT{~,,~}
Z 'TADP'='TADP'(AL,P,BE,Q,GA,K)
Id,CONTR(K1~,K2~,K3~)=CONT(K1,K2,K3,/,"K)
   *VE3(K1,K2,K3,*,AL,P,*,BE,Q,*,GA,K)/EP
Id,Compo,<SS>,CONT,<X>,VE3
Id,CONT(S~)=S
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=AA(MU,P0,L2,Q,L1,P)
CVERT{~,~,}
SCVERT{~,~,}
Id,C2MS2=2*C**2-1
E1EZF{,,~,~,~}
B EP,TIPI2
Id,Count,1,EP,-2,E1F,-2,EZF,-2
Id,Multi,S**2=1-C**2
Al,Q(MU~)=-P(MU)-K(MU)
P output
*yep
Id,DEL=-1
*next
P input
ENDBLOCK
P input
Z IAOP(MU,Q,NU,T,AL,K)=VERT("A,"P_,"P)
WORK{IAOP}
Z IAXY(MU,Q,NU,T,AL,K)=VERT("A,"Y_,"Y)
WORK{IAXY}
Z IFOP(MU,Q,NU,T,AL,K)=VERT("F,"P_,"P)
WORK{IFOP}
Z IFXY(MU,Q,NU,T,AL,K)=VERT("F,"Y_,"Y)
WORK{IFXY}
Z IGPQ(MU,Q,NU,T,AL,K)=VERT("G,"P,"R_)
WORK{IGPQ}
Z IGRX(MU,Q,NU,T,AL,K)=VERT("G,"R,"Y_)
WORK{IGRX}
Z IGTX(MU,Q,NU,T,AL,K)=VERT("G,"T,"Y_)
WORK{IGTX}
Z IHOR(MU,Q,NU,T,AL,K)=VERT("G_,"P_,"R)
WORK{IHOR}
Z IHOT(MU,Q,NU,T,AL,K)=VERT("G_,"P_,"T)
WORK{IHOT}
Z IHQY(MU,Q,NU,T,AL,K)=VERT("G_,"R_,"Y)
WORK{IHQY}
Z IOPZ(MU,Q,NU,T,AL,K)=VERT("P_,"P,"Z)
WORK{IOPZ}
Z IOPW(MU,Q,NU,T,AL,K)=VERT("P_,"P,"W)
WORK{IOPW}
Z IORV(MU,Q,NU,T,AL,K)=VERT("P_,"R,"U_)
WORK{IORV}
Z IOTV(MU,Q,NU,T,AL,K)=VERT("P_,"T,"U_)
WORK{IOTV}
Z IPQU(MU,Q,NU,T,AL,K)=VERT("P,"R_,"U)
WORK{IPQU}
Z IPSU(MU,Q,NU,T,AL,K)=VERT("P,"T_,"U)
WORK{IPSU}
Z IQRZ(MU,Q,NU,T,AL,K)=VERT("R_,"R,"Z)
WORK{IQRZ}
Z IQTZ(MU,Q,NU,T,AL,K)=VERT("R_,"T,"Z)
WORK{IQTZ}
Z IQVY(MU,Q,NU,T,AL,K)=VERT("R_,"U_,"Y)
WORK{IQVY}
Z IRUX(MU,Q,NU,T,AL,K)=VERT("R,"U,"Y_)
WORK{IRUX}
Z ISVY(MU,Q,NU,T,AL,K)=VERT("T_,"U_,"Y)
WORK{ISVY}
Z ITUX(MU,Q,NU,T,AL,K)=VERT("T,"U,"Y_)
WORK{ITUX}
Z IWXY(MU,Q,NU,T,AL,K)=VERT("W,"Y_,"Y)
WORK{IWXY}
Z IXYZ(MU,Q,NU,T,AL,K)=VERT("Y_,"Y,"Z)
WORK{IXYZ}
*end

C RO-parameter 5. Two-loop self-energy diagrams.

C TWO-LOOP SELF-ENERGY DIAGRAMS.
C THE DIAGRAMS ARE DIVIDED IN 8 TOPOLOGY CLASSES.
C EACH CLASS IS WORKED OUT IN TERMS OF THE F211 ETC.
C SUBSEQUENTLY THE F211 ETC ARE EXPANDED IN TERMS OF THE
C  HIGGS MASS SM.
C CDC CPU time: 111.85 sec.

Common A0A0,W0A0,W0W0,WPWM

S PM=1,M,M0,SM,N,C,S,EP,AH
Oldnew i=I
P ninput
Read Roblocks.e
VERT{,,,~,~}
X NUM(K1,K2)=1.-0.5*DK(K1,K2)
X NUM3(K1,K2,K3)=1-0.5*DK(K1,K2)-0.5*DK(K1,K3)-0.5*DK(K2,K3)
     +2/3*DK(K1,K2)*DK(K1,K3)
X KUM(K1)=1-DK("Z,K1)
C X KUM(K1)=1-DK(4,K1)
X ZUM(K1,K2,K3,K4,K5)=1-KUM(K1)*KUM(K2)*KUM(K3)*KUM(K4)*KUM(K5)
F FP3,FP2,FP1,FQ2,FQ1,FK1
*fix
P ninput
BLOCK WORK{}
P ninput
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,NOM(P,M~)*NOM(P,S~)*NOM(P,C~)=FP3(M,S,C)
Al,NOM(P,M~)*NOM(P,S~)=FP2(M,S)
Al,NOM(P,M~)=FP1(M)
Al,NOM(Q,M~)*NOM(Q,S~)=FQ2(M,S)
Al,NOM(Q,M~)=FQ1(M)
Al,NOM(K,M~)=FK1(M)
*yep
Id,QDP=0.5*KDK-0.5*PDP-0.5*QDQ
Al,QDK=-0.5*PDP+0.5*KDK+0.5*QDQ
Al,PDK=-0.5*QDQ+0.5*KDK+0.5*PDP
Id,Multi,S**2=1-C**2
Al,C2MS2=2*C**2-1
*yep
C AT MOST FQ2, FK1, NOT FQ3 OR FK2
C AT MOST QDQ**2, KDK**2.
Id,QDQ**2*FQ2(M~,M0~)=1.-(M**2+M0**2)*FQ1(M0)+M**4*FQ2(M,M0)
Al,KDK**2*FK1(M~)=PDP+QDQ-M**2+M**4*FK1(M)
Al,QDQ**2*FQ1(M~)=QDQ-M**2+M**4*FQ1(M)
C NOW NO MORE QDQ**2 OR KDK**2.
Id,QDQ*FQ2(M~,M0~)=FQ1(M0)-M**2*FQ2(M,M0)
Al,QDQ*FQ1(M~)=1.-M**2*FQ1(M)
Al,QDQ*FK1(M~)=PDP*FK1(M)+1.-M**2*FK1(M)
Al,KDK*FK1(M~)=1.-M**2*FK1(M)
Id,PDP**2*FP3(M~,M0~,S~)=FP1(S)-(M**2+M0**2)*FP2(M0,S)
       +M**4*FP3(M,M0,S)
Al,PDP**2*FP2(M~,M0~)=1.-(M**2+M0**2)*FP1(M0)+M**4*FP2(M,M0)
Al,PDP**2*FP1(M~)=PDP-M**2+M**4*FP1(M)
Id,PDP*FP3(M~,M0~,S~)=FP2(M0,S)-M**2*FP3(M,M0,S)
Al,PDP*FP2(M~,M0~)=FP1(M0)-M**2*FP2(M,M0)
Al,PDP*FP1(M~)=1.-M**2*FP1(M)
Id,FQ2(M~,M0~)=FP2(M,M0)
Al,FQ1(M~)=FP1(M)
Al,FK1(M~)=FP1(M)
Id,Commu,FP3,FP2,FP1
*yep
Id,FP3(M~,S~,C~)*FP2(M0~,SM~)=F32(M,S,C,M0,SM)
Al,FP3(M~,S~,C~)*FP1(M0~)*FP1(SM~)=F311(M,S,C,M0,SM)
Al,FP3(M~,S~,C~)*FP1(M0~)=F31(M,S,C,M0)
Al,FP3(M~,S~,C~)=0
Id,FP2(M~,S~)*FP2(M0~,C~)*FP1(SM~)=F221(M,S,M0,C,SM)
Al,FP2(M~,S~)*FP2(M0~,C~)=F22(M,S,M0,C)
Al,FP2(M~,S~)*FP1(M0~)*FP1(C~)=F211(M,S,M0,C)
Al,FP2(M~,S~)*FP1(M0~)=F21(M,S,M0)
Al,FP2(M~,S~)=0
Id,FP1(M~)*FP1(S~)*FP1(C~)=F111(M,S,C)
Al,FP1(M~)*FP1(S~)=F11(M,S)
Al,FP1(M~)=0
*yep
Id,F311(M~,S~,C~,M0~,SM~)=F311(M,S,C,M0,SM)*YYYY(C,SM)
Al,F31(M~,S~,C~,M0~)=F31(M,S,C,M0)*XXXX(C,M0)
Id,YYYY(SM,SM)=1./ATEL9**2
Al,YYYY(M~,SM)=1.
Al,YYYY(SM,M~)=1./ATEL9**2
Al,YYYY(S~,C~)=1.
Al,XXXX(SM,SM)=1.
Al,XXXX(M~,SM)=ATEL9**2
Al,XXXX(SM,M~)=1./ATEL9**2
Al,XXXX(C~,S~)=1.
Id,F221(M~,M0~,C~,S~,SM~)=F221(M,M0,C,S,SM)/ATEL9**2
Al,F21(M~,M0~,SM)=F21(M,M0,SM)*ATEL9**2
Al,F111(M~,M0~,SM)=F111(M,M0,SM)*ATEL9**2
Id,Count,1,ATEL9,1,SM,1
Id,ATEL9=1
Al,Multi,ATEL9**-1=1
C Nprint A0A0,W0A0,W0W0,WPWM
ENDBLOCK
BLOCK TOPO{}
Id,TOPA(I1~,I2~)=
   DS(I1;J1;J4;Sym;J1;J4;TAP,(
     DS(J3;J2;-J1;TAP,(
       DS(-J2;-J5;I2;TAP,(
   DC("T,THI,-1,J1,J2,J3,J4,J5)*
   DIA(I1,I2,J1,-J1,J2,-J2,J3,-J3,J4,-J4,J5,-J5) )) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K7,*,MU,P0,*,L1,P,*,L7,-P)*
   VE3(K2,K3,K5,*,L2,-P,*,L3,-Q,*,L5,K)*
   VE3(K4,I2,K0,*,L4,Q,*,NU,-P0,*,L0,-Q)*
   VE3(K6,K8,K9,*,L6,-K,*,L8,P,*,L9,Q)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*
   PROP(K7,K8,*,L7,P,*,L8,P)*
   PROP(K9,K0,*,L9,Q,*,L0,Q)*D(MU,NU)/N
ENDBLOCK
Z A0A0=TOPA("A,"A)
TOPO{}
WORK{}
*next
Z W0A0=TOPA("W,"A)
TOPO{}
WORK{}
*next
Z W0W0=TOPA("W,"W)
TOPO{}
WORK{}
*next
Z WPWM=TOPA("U,"U_)
TOPO{}
WORK{}
*next
BLOCK TOP1{}
Id,TOPB(I1~,I2~)=
   DS(I1;-J1;-J2;TAP,(
     DS(J2;-J3;-J4;Sym;-J3;-J4;TAP,(
       DS(J3;J4;-J5;TAP,(
   DC("T,THI,-1,J1,J2,J3,J4,J5)*
   DIA(I1,I2,-J1,J1,-J2,J2,-J5,J5,-J3,J3,J4,-J4) )) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K3,*,MU,P0,*,L1,P,*,L3,-P)*
   VE3(K2,I2,K6,*,L2,-P,*,NU,-P0,*,L6,P)*
   VE3(K4,K7,K0,*,L4,P,*,L7,-K,*,L0,Q)*
   VE3(K5,K8,K9,*,L5,-P,*,L8,K,*,L9,-Q)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,P,*,L4,P)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,K,*,L8,K)*
   PROP(K9,K0,*,L9,Q,*,L0,Q)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+TOPB("A,"A)
TOP1{}
WORK{}
*next
Z W0A0=W0A0+TOPB("W,"A)
TOP1{}
WORK{}
*next
Z W0W0=W0W0+TOPB("W,"W)
TOP1{}
WORK{}
*next
Z WPWM=WPWM+TOPB("U,"U_)
TOP1{}
WORK{}
*next
BLOCK TOP2{}
Id,TOPC(I1~,I2~)=
   DS(I1;-J1;-J2;I2;Sym;J1;J2;TAP,(
     DS(J1;-J3;-J4;Sym;J3;J4;TAP,(
     DC("T,THI,-1,J1,J2,J3,J4)*
     DIA(I1,I2,-J1,J1,-J2,J2,-J3,J3,J4,-J4) )) ))

Id,Anti,TAP

C    DS(J1,1,8,(DS(J2,J1,8,(
C    DC(QN(I1),QN(I2),QH(J1),QH(J2))*(NUM(J1,J2))*
C    DS(J3,1,8,(DS(J4,J3,8,(
C    DC(QG(J1),QH(J3),QH(J4))*(NUM(J3,J4)*ZUM(J1,J2,J3,J4,3))*
C    DIA(I1,I2,CHH(J1),CHG(J1),CHH(J2),CHG(J2),
C        CHH(J3),CHG(J3),CHG(J4),CHH(J4) )  )))) ))))
Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE4(I1,K1,K3,I2,*,MU,*,L1,*,L3,*,NU)*
   VE3(K2,K5,K8,*,L2,P,*,L5,-K,*,L8,Q)*
   VE3(K4,K6,K7,*,L4,-P,*,L6,K,*,L7,-Q)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,P,*,L4,P)*
   PROP(K5,K6,*,L5,K,*,L6,K)*
   PROP(K7,K8,*,L7,Q,*,L8,Q)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+TOPC("A,"A)
TOP2{}
WORK{}
*next
Z W0A0=W0A0+TOPC("W,"A)
TOP2{}
WORK{}
*next
Z W0W0=W0W0+TOPC("W,"W)
TOP2{}
WORK{}
*next
Z WPWM=WPWM+TOPC("U,"U_)
TOP2{}
WORK{}
*next
BLOCK TOP3{}
Id,TOPD(I1~,I2~)=
  DS(I1;-J1;-J2;I2;Sym;J1;J2,TAP,(
   DS(J1;J2;-J3;J3;Sym;J3;-J3,TAP,(
   DIA(I1,I2,-J1,J1,-J2,J2,-J3,J3) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE4(I1,K1,K3,I2,*,MU,*,L1,*,L3,*,NU)*
   VE4(K2,K4,K5,K6,*,L2,*,L4,*,L5,*,L6)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,P,*,L4,P)*
   PROP(K5,K6,*,L5,Q,*,L6,Q)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+TOPD("A,"A)
TOP3{}
WORK{}
*next
Z W0A0=W0A0+TOPD("W,"A)
TOP3{}
WORK{}
*next
Z W0W0=W0W0+TOPD("W,"W)
TOP3{}
WORK{}
*next
Z WPWM=WPWM+TOPD("U,"U_)
TOP3{}
WORK{}
*next
BLOCK TOP4{}
Id,TOPE(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J2;-J4;J4;J3;Sym;-J4;J4;TAP,(
     DIA(I1,I2,-J1,J1,-J4,J4,-J2,J2,J3,-J3) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,P0,*,L1,-P,*,L5,P)*
   VE3(K2,I2,K8,*,L2,P,*,NU,-P0,*,L8,-P)*
   VE4(K6,K3,K4,K7,*,L6,*,L3,*,L4,*,L7)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,P,*,L8,P)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+TOPE("A,"A)
TOP4{}
WORK{}
*next
Z W0A0=W0A0+TOPE("W,"A)
TOP4{}
WORK{}
*next
Z W0W0=W0W0+TOPE("W,"W)
TOP4{}
WORK{}
*next
Z WPWM=WPWM+TOPE("U,"U_)
TOP4{}
WORK{}
*next
BLOCK TOP5{}
Id,TOPF(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J3;J2;J4;Sym;J3;J4,TAP,(
   DC("T,THI,-1,J1,J2,J3,J4)*
   DIA(I1,I2,-J1,J1,J3,-J3,-J2,J2,J4,-J4) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,P0,*,L1,P,*,L5,-P)*
   VE4(K2,I2,K4,K8,*,L2,*,NU,*,L4,*,L8)*
   VE3(K3,K6,K7,*,L3,-K,*,L6,P,*,L7,Q)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,K,*,L4,K)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,Q,*,L8,Q)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+2*TOPF("A,"A)
TOP5{}
WORK{}
*next
Z W0A0=W0A0+TOPF("W,"A)+TOPF("A,"W)
TOP5{}
WORK{}
*next
Z W0W0=W0W0+2*TOPF("W,"W)
TOP5{}
WORK{}
*next
Z WPWM=WPWM+TOPF("U,"U_)+TOPF("U_,"U)
TOP5{}
WORK{}
*next
BLOCK TOP6{}
Id,TOPH(I1~,I2~)=
    DS(I1;-J1;-J2;-J3;Sym;-J1;-J2;-J3,TAP,(
    DC("T,THI,-1,J1,J2,J3)*
    DIA(I1,I2,-J1,J1,-J2,J2,-J3,J3) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE4(I1,K1,K3,K5,*,MU,*,L1,*,L3,*,L5)*
   VE4(I2,K2,K4,K6,*,NU,*,L2,*,L4,*,L6)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*D(MU,NU)/N
ENDBLOCK
Z A0A0=A0A0+TOPH("A,"A)
TOP6{}
WORK{}
Print A0A0
*next
Z W0A0=W0A0+TOPH("W,"A)
TOP6{}
WORK{}
Print W0A0
*next
Z W0W0=W0W0+TOPH("W,"W)
TOP6{}
WORK{}
Print W0W0
*next
Z WPWM=WPWM+TOPH("U,"U_)
TOP6{}
WORK{}
Print WPWM
*next
Z A0A0=A0A0
Z W0A0=W0A0
Z W0W0=W0W0
Z WPWM=WPWM
*yep
P input
Id,F22(M~,M0~,S~,C~)=F221(M,M0,S,C,AH)
Al,F31(M~,M0~,S~,C~)=F311(M,M0,S,C,AH)
Al,F21(M~,M0~,S~)=F211(M,M0,S,AH)
Id,F221(M~,M~,M0~,M0~,SM~)=FF221(M,M,M0,M0,SM)
Al,F221(M~,M~,C~,S~,SM~)=DIF(C,S)*F211(M,M,S,SM)
                              -DIF(C,S)*F211(M,M,C,SM)
Al,F221(C~,S~,M0~,M~,SM~)=DIF(C,S)*F211(M0,M,S,SM)
                               -DIF(C,S)*F211(M0,M,C,SM)
Id,FF221(M~,M~,C~,C~,S~)=F221(M,M,C,C,S)
Al,F311(M~,M~,M~,C~,S~)=FF311(M,M,M,C,S)
Al,F311(M~,SM~,M0~,C~,S~)=DIF(M,M0)*F211(SM,M0,C,S)
                                   -DIF(M,M0)*F211(M,SM,C,S)
Id,FF311(M~,M~,M~,C~,S~)=F311(M,M,M,C,S)
Al,F211(M~,M~,C~,S~)=FF211(M,M,C,S)
Al,F211(C~,S~,M~,M0~)=DIF(C,S)*F111(S,M,M0)
                              -DIF(C,S)*F111(C,M,M0)
Id,FF211(M~,M~,C~,S~)=F211(M,M,C,S)
Id,F111(M~,C~,AH)=F11(M,C)
Al,F111(M~,C~,S~)=(EP-EP**2-1)*(M**2*F211(M,M,C,S)
                 +C**2*F211(C,C,M,S)+S**2*F211(S,S,M,C))
Id,F11(PM,M~)=0
Al,F11(M~,PM)=0
Id,Symme,F211,3,4,F311,4,5,F111,1,2,3
Id,Symme,F211,1,2,F311,1,2,3,F11,1,2
Id,Asymm,DIF,1,2
*yep
Id,DIF(M,SM)=-1./SM**2-M**2/SM**4-M**4/SM**6
Al,DIF(M0,SM)=-1./SM**2-M0**2/SM**4-M0**4/SM**6
Al,DIF(PM,M~)=-1./M**2
Al,DIF(M,M0)=-C**2/M**2/S**2
Id,Multi,M0**2=M**2/C**2
Al,Multi,M0**-2=C**2/M**2
Id,F221(M~,M0~,S~,C~,AH)=F22(M,M0,S,C)
Al,F311(M~,M0~,S~,C~,AH)=F31(M,M0,S,C)
Al,F211(M~,M0~,S~,AH)=F21(M,M0,S)
Id,EP**2*N=4.*EP**2
Al,N=4+EP
Al,EP**2*N**-1=0.25*EP**2
Al,EP*N**-1=EP/4.-EP**2/16.
Al,N**-1=1/4-EP/16+EP**2/64
Id,EP**2*F22(M~,M0~,S~,C~)=-4.*PI**4
Al,EP**2*F31(M~,M0~,S~,C~)=0.
Al,EP**2*F21(M~,M0~,S~)=4.*PI**4*S**2
Al,EP**2*F11(M~,M0~)=-4.*PI**4*M**2*M0**2
Al,EP**2*F221(M~,M0~,S~,C~,SM~)=0.
Al,EP**2*F311(M~,M0~,S~,C~,SM~)=0.
Al,EP**2*F211(M~,M0~,S~,C~)=-2.*PI**4
Id,EP*F3(M~,S~,C~)=0.
Al,EP**2*F3(M~,S~,C~)=0
Al,EP*F2(M~,C~)=-2.*I*PI**2
Al,EP**2*F2(M~,C~)=0.
Id,Multi,M0**2=M**2/C**2
*yep
Id,Multi,C**2=1-S**2
*yep
Id,Multi,S**2=1-C**2
Id,C**2*F211(M~,M0~,PM,SM~)=(1-S**2)*F211(M,M0,PM,SM)
Al,C**2*F3(PM,M~,M0~)=(1-S**2)*F3(PM,M,M0)
Al,C**2*F11(PM,M~)=(1-S**2)*F11(PM,M)
*yep
F21F22{}
Id,F22(M~,M~,M0~,M0~)=F(2,M)*F(2,M0)
Al,F21(M~,M~,M0~)=F(2,M)*F(1,M0)
Al,F31(M~,M~,M~,M0~)=F(3,M)*F(1,M0)
Al,F11(M~,M0~)=F(1,M)*F(1,M0)
Id,F(1,PM)=0
F1t5{}
Id,EP=0
B EP,I,PI2,TIPI2
Id,Count,1,SM,1
Id,LG(SM,M~)=LG(SM)-LG(M)
Al,LG(M0,M~)=LG(M0)-LG(M)
Al,LG(M,M0~)=LG(M)-LG(M0)
Id,Multi,M0**2=M**2/C**2
Al,PI**4=-0.25*TIPI2**2
Id,Commu,LG
*yep
Id,C**-6*S**-4=1/C**6/S**2+1/C**4/S**4
Id,C**-6*S**-2=1/C**6+1/C**4/S**2
Id,C**-2*S**-2=1/C**2+1/S**2
Al,C**-2*S**-4=1/C**2+1/S**2+1/S**4
Al,C**-4*S**-2=1/C**4+1/C**2+1/S**2
Al,C**-4*S**-4=1/C**4+2/C**2+2/S**2+1/S**4
Id,Multi,C**2=1-S**2
Id,Multi,S**2=1-C**2
*begin
Write comm2lp
*end

C RO-parameter 6. One-loop subtractions. RO-parameter result.

C ONE-LOOP SUBTRACTIONS AND RO-PARAMETER CALCULATION.
C NOT CONSIDERED ARE TADPOLE DIAGRAMS WITH INSERTED CORRECTIONS.
C ALTHOUGH THEY ARE IMPORTANT FOR GAUGE INVARIANCE OF THE WW LINES,
C THEY ARE NOT OF ANY CONSEQUENCE TO THE RO-PARAMETER.
C BELOW THEY ARE MADE INACTIVE.
C ENTER RESULT FROM TWO-LOOP SELF-ENERGY DIAGRAMS.
C THESE ARE THE FILES A0A0, W0A0, W0W0 AND WPWM.
C CDC CPU time 28.15 SEC.

Oldnew i=I
Enter comm2lp
Common SWA,SPM,SWW,SAA
P ninput
Read Roblocks.e
VERT{,,,~,~}
SVERT{,,}
X NUM(K1,K2)=1-0.5*DK(K1,K2)
*fix
P ninput
BLOCK WORK{TADP}
P ninput
B ET,EP,I,PI2,DEL,TIPI2
Id,Compo,<X>,VE4,VE3,PROP
Id,Compo,<SS>,CONT
Id,Adiso,CONT(S~)*CONT(C~)=S/EP+C/EP
Al,CONT(S~)=S/EP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,NOM(P,M~)*NOM(P,M0~)*NOM(P,SM~)=F3(M,M0,SM)
Al,NOM(P,M~)*NOM(P,M0~)=F2(M,M0)
Al,NOM(P,M~)=F(1,M)
Al,ZERO**2=0
*yep
Id,F(1,PM)=0
Al,PM=0
Id,PDP**2*F3(M~,M0~,SM~)=F(1,SM)-(M**2+M0**2)*F2(M0,SM)
    +M**4*F3(M,M0,SM)
Al,PDP*F3(M~,M0~,SM~)=F2(M0,SM)-M**2*F3(M,M0,SM)
Al,PDP*F2(M~,M0~)=F(1,M0)-M**2*F2(M,M0)
Id,F(1,PM)=0
Al,PM=0
Id,F3(M~,M0~,SM)=1/ATEL9**2*F3(M,M0,SM)
Al,F(1,SM)=ATEL9**2*F(1,SM)
Id,Count,-1,ATEL9,1,SM,1,E1,2,E2,2,ET,2,EZF,2
Id,Multi,M0**2=M**2/C**2
Al,ATEL9=1
Al,Multi,ATEL9**-1=1
Id,Multi,S**2=1.-C**2
*yep
Id,Symme,F2,1,2,F3,1,2,3
Id,F3(M~,M~,M~)=F(3,M)
Al,F3(M~,M~,SM~)=F3(SM,M,M)
Id,F3(SM~,M0~,M~)=DIF(M0,SM)*(F2(SM,M)-F2(M0,M))
Id,F2(M~,M~)=F(2,M)
Al,F2(M~,M0~)=DIF(M0,M)*(F(1,M)-F(1,M0))
Id,F(1,PM)=0
Al,PM=0
Id,Asymm,DIF,1,2
Id,DIF(PM,M~)=-1/M**2
Al,DIF(M,M0)=-C**2/M**2/S**2
Al,DIF(M~,SM)=-(1+M**2/SM**2+M**4/SM**4+M**6/SM**6)/SM**2
Id,F(1,SM)=ATEL9**2*F(1,SM)
Al,F(3,SM)=F(3,SM)/ATEL9**2
Id,Count,-1,ATEL9,1,SM,1,E1,2,E2,2,ET,2,EZF,2
Id,Numer,ATEL9,1.
F1t5{}
Id,Once,PI**2=-I*TIPI2/2
Id,N**-1=0.25-EP/16+EP**2/64
Al,N=4+EP
Id,EP=0
Id,Multi,M0**2=M**2/C**2
Id,Multi,M0**-1=C**2/M**2
Id,Multi,C**2=1.-S**2
Id,Multi,S**2=1.-C**2
*yep
CVERT{,,~}
SCVERT{,,~}
Id,ZERO=0.
Id,Count,1,SM,1,E1,2,E2,2,ET,2,EZF,2
Id,C2MS2=2*C**2-1
E1EZF{,,~,,}
Id,PI**6=-PI2*TIPI2**2/4
Id,Commu,LG
Id,EP=0
Id,Count,1,SM,1,ET,2
Id,C**-2*S**-4=1/S**4+1/S**2+1/C**2
Al,C**-2*S**-2=1/S**2+1/C**2
P input
ENDBLOCK
BLOCK SELF{}
P ninput
Id,SELF(I1~,I2~)=
    DS(I1;J1;J2;Sym;J1;J2,TAP,(DIB(I1,J1,-J1,J2,-J2,I2) ))
  + DS(I1;J3;-J3;I2;Sym;J3;-J3,TAP,(DIC(I1,J3,-J3,I2) ))
  + DS(I1;J4;-J5,TAP,(DS("N;J5;-J6,TAP,(DID(I1,I2,"N,J4,-J5,J5,-J6,J6,-J4) ))))
  + DS(I1;J7;-J8;I2;Sym;J7;-J8,TAP,(DIE(I1,I2,"N,J7,-J7,J8,-J8) ))

Id,Anti,TAP

Id,DIB(I1~,K1~,K2~,K3~,K4~,I2~)=
   VE3(I1,K1,K3,*,MU,P0,*,L1,-P,*,L3,P)*
   VE3(K2,I2,K4,*,L2,P,*,NU,-P0,*,L4,-P)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,P,*,L4,P)
   *D(MU,NU)/N
  *CONT(I1,K1,K3,/,"K)*CONT(K2,I2,K4,/,"K)
Id,DIC(I1~,K1~,K2~,I2~)=
   VE4(I1,K1,K2,I2,*,MU,*,L1,*,L2,*,NU)*
   PROP(K1,K2,*,L1,P,*,L2,P)
    *D(MU,NU)/N
   *CONT(I1,K1,K2,I2,/,"K)
Al,DID(I1~,I2~,I3~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE3(I1,K1,K2,*,MU,P0,*,L1,P,*,L2,-P)*
   VE3(I3,K3,K4,*,AL,K,*,L3,P,*,L4,-P)*
   VE3(I2,K5,K6,*,NU,-P0,*,L5,P,*,L6,-P)*
   PROP(K6,K1,*,L6,P,*,L1,P)*
   PROP(K2,K3,*,L2,P,*,L3,P)*
   PROP(K4,K5,*,L4,P,*,L5,P)
   *D(MU,NU)/N   /EP
Al,DIE(I1~,I2~,I3~,K1~,K2~,K3~,K4~)=
   VE4(I1,K1,K4,I2,*,MU,*,L1,*,L4,*,NU)*
   VE3(I3,K2,K3,*,AL,K,*,L2,P,*,L3,-P)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,P,*,L4,P)
   *D(MU,NU)/N   /EP
ENDBLOCK
Z SWA=SELF("W,"A)
SELF{}
WORK{SWA}
*next
Z SPM=SELF("U,"U_)
SELF{}
WORK{SPM}
*next
P input
Z SWW=SELF("W,"W)
SELF{}
WORK{SWW}
*next
P input
Z SAA=SELF("A,"A)
SELF{}
WORK{SAA}
*next
S EP,TIPI2,N,PM,M,M0,SM,C,S
F LG
B EP,I,PI2,TIPI2
Z SAA=SAA
Z SWA=SWA-4*M**2*S/C*E1F*TIPI2/EP**2
Z SWW=SWW-M**2*TIPI2/EP**2*(-E1F/C**4+43/12*ET/C**2
       -55/6*E1F/C**2-E1F**2/C**2/TIPI2+8*E1F)
Z SPM=SPM-M**2*TIPI2/EP**2*(-E1F/C**2+43/12*ET
       -7/6*E1F-E1F**2/TIPI2)
E1EZF{~,~,,,}
Id,EP=0
Id,Count,1,SM,1
Id,Commu,LG
Id,C**-2*S**-2=1/S**2+1/C**2
Id,LG(M~,SM)=LG(M)-LG(SM)
Al,LG(M~,M0)=LG(M)-LG(M0)
Al,LG(M0~,M)=LG(M0)-LG(M)
Id,Commu,LG
*next
S EP,TIPI2,N,PM,M,M0,SM,C,S
B EP,I,PI2,TIPI2
F LG
Z RWPWM=WPWM-SPM
Z RW0W0=W0W0-SWW
Id,C**-2*S**-2=1/S**2+1/C**2
Id,LG(M)=LG(M,SM)+LG(SM)
Al,LG(M0)=LG(M0,SM)+LG(SM)
Id,Commu,LG
Id,LG(M~,SM)*LG(SM)=LG(SM)*LG(M,SM)
*next
S EP,TIPI2,N,PM,M,M0,SM,C,S
B M,SM,C,S
F LG
Z RO=-(WPWM-C**2*W0W0-SPM+C**2*SWW)/TIPI2**2/PI**4/64/M**2
Id,Multi,TIPI2**-1=0.5/PI**2/I
Id,Commu,LG
Id,C**-2*S**-2=1/S**2+1/C**2
Id,LG(M)=LG(M,SM)+LG(SM)
Al,LG(M0)=LG(M0,SM)+LG(SM)
Id,Commu,LG
Id,LG(M~,SM)*LG(SM)=LG(SM)*LG(M,SM)
*yep
Id,C**-2=1+S**2/C**2
*begin
Write common
*end

C RO-parameter 7. Two-loop self-energy diagrams. A-A wave-function.

Oldnew i=I
P ninput
Read Roblocks.e
Common AAWF
VERT{,,,~,~}
C P input
X NUM(K1,K2)=1.-0.5*DK(K1,K2)
X NUM3(K1,K2,K3)=1-0.5*DK(K1,K2)-0.5*DK(K1,K3)-0.5*DK(K2,K3)
     +2/3*DK(K1,K2)*DK(K1,K3)
X KUM(K1)=1-DK(4,K1)
X ZUM(K1,K2,K3,K4,K5)=1-KUM(K1)*KUM(K2)*KUM(K3)*KUM(K4)*KUM(K5)
S PM=1,EI=2,NP1,TRN
V QL,PX,QX
*fix
Z AAWF=0
Nprint AAWF
*next
BLOCK WORK{AAWFA}
C P ninput
PROJ{,,~,}
F21F51{}
Id,Count,1,SM,1
*yep
Id,FSC(N~,M~)=F(N,M)*M**N*M**N/M**4
F1t5{}
Id,EP=0
*yep
NEXP{}
Id,EP=0
B EP,I,PI2,TIPI2,LE2
Id,Count,1,SM,1
Id,LG(SM,M~)=LG(SM)-LG(M)
Al,LG(M0,M~)=LG(M0)-LG(M)
Al,LG(M,M0~)=LG(M)-LG(M0)
Id,Multi,M0**2=M**2/C**2
Al,PI**4=-0.25*TIPI2**2
Id,Commu,LG
Keep 'AAWFA'
*next
Z AAWF=AAWF+'AAWFA'
Nprint AAWF
B EP,I,PI2,TIPI2,LE2
ENDBLOCK
BLOCK TOPO{}
Id,TOPA(I1~,I2~)=
   DS(I1;J1;J2;Sym;J1;J2;TAP,(
     DS(-J1;J5;"Z;TAP,(
       DS(-J5;I2;-J4;TAP,(
   DIA(I1,I2,J1,-J1,J5,-J5,"Z,"Z,J2,-J2,J4,-J4) )) )) ))
Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K7,*,MU,LE,*,L1,P,*,L7,-PL)*
   VE3(K2,K3,K5,*,L2,-P,*,L3,-Q,*,L5,K)*
   VE3(K4,I2,K0,*,L4,Q,*,NU,-LE,*,L0,-QL)*
   VE3(K6,K8,K9,*,L6,-K,*,L8,PL,*,L9,QL)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*
   PROP(K7,K8,*,L7,PL,*,L8,PL)*
   PROP(K9,K0,*,L9,QL,*,L0,QL)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PXDPX+2*PXDLE*E*(1-X)+LEDLE*E**2/3
Al,Dotpr,PL(MU~)=PX(MU)+LE(MU)*(1-X)*E
Al,PL(MU~)=PX(MU)+LE(MU)*(1-X)*E
Id,QLDQL=QXDQX-2*QXDLE*E*(1-X)+LEDLE*E**2/3
Al,Dotpr,QL(MU~)=QX(MU)-LE(MU)*(1-X)*E
Al,QL(MU~)=QX(MU)-LE(MU)*(1-X)*E
Id,PDP=PXDPX-2*X*PXDLE*E+LEDLE*E**2/3
Al,Dotpr,P(MU~)=PX(MU)-X*LE(MU)*E
Al,P(MU~)=PX(MU)-X*LE(MU)*E
Id,QDQ=QXDQX+2*X*QXDLE*E+LEDLE*E**2/3
Al,Dotpr,Q(MU~)=QX(MU)+X*LE(MU)*E
Al,Q(MU~)=QX(MU)+X*LE(MU)*E
Id,PXDPX=PDP
Al,Dotpr,PX(MU~)=P(MU)
Al,PX(MU~)=P(MU)
Id,QXDQX=QDQ
Al,Dotpr,QX(MU~)=Q(MU)
Al,QX(MU~)=Q(MU)
*yep
Id,Adiso,NOM(P,M~)*NOM(PL,M~)=FP(2,M)-1/3*LEDLE*FP(3,M)*E**2
Id,Adiso,NOM(Q,M~)*NOM(QL,M~)=FQ(2,M)-4*QDLE*(X-Y)*FQ(3,M)*E
   -2/3*LEDLE*FQ(3,M)*E**2+2*QDLE**2*FQ(4,M)*E**2
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,X**N~=1/(N+1)
Al,Y**N~=1/(N+1)
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AAWFA=TOPA("A,"A)
TOPO{}
WORK{AAWFA}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPB(I1~,I2~)=
   DS(I1;-J1;-J2;TAP,(
     DS(J2;"Z;-J4;TAP,( DC("P,TAP,-1,"Z,J4)*
       DS(J1;I2;J5,TAP,(
   DIA(I1,I2,-J1,J1,-J2,J2,-J5,J5,"Z,"Z,J4,-J4) ))) )))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K3,*,MU,-LE,*,L1,PL,*,L3,-P)*
   VE3(K2,I2,K6,*,L2,-PL,*,NU,LE,*,L6,P)*
   VE3(K4,K7,K0,*,L4,P,*,L7,-K,*,L0,Q)*
   VE3(K5,K8,K9,*,L5,-P,*,L8,K,*,L9,-Q)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,P,*,L4,P)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,K,*,L8,K)*
   PROP(K9,K0,*,L9,Q,*,L0,Q)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
   FP(3,M)-2*PDLE*FP(4,M)*E
   -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AAWFB=TOPB("A,"A)
TOPO{}
WORK{AAWFB}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPE(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J2;-J4;J4;J3;Sym;-J4;J4;TAP,(
     DIA(I1,I2,-J1,J1,-J4,J4,-J2,J2,J3,-J3) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,LE,*,L1,-PL,*,L5,P)*
   VE3(K2,I2,K8,*,L2,PL,*,NU,-LE,*,L8,-P)*
   VE4(K6,K3,K4,K7,*,L6,*,L3,*,L4,*,L7)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,P,*,L8,P)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
   FP(3,M)-2*PDLE*FP(4,M)*E
   -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Al,NOM(Q,M~)=FQ(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AAWFE=TOPE("A,"A)
TOPO{}
WORK{AAWFE}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPF(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS("Z;J2;J4;TAP,( DC("P,TAP,-1,"Z,J4)*
   DIA(I1,I2,-J1,J1,"Z,"Z,-J2,J2,J4,-J4) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,-LE,*,L1,PL,*,L5,-P)*
   VE4(K2,I2,K4,K8,*,L2,*,NU,*,L4,*,L8)*
   VE3(K3,K6,K7,*,L3,-K,*,L6,P,*,L7,Q)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,K,*,L4,K)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,Q,*,L8,Q)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(PL,M~)=FP(2,M)-2*PDLE*FP(3,M)*E
   -LEDLE*E**2*FP(3,M)+4*PDLE**2*E**2*FP(4,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AAWFF=2*TOPF("A,"A)
TOPO{}
WORK{AAWFF}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPH(I1~,I2~)=
    DS(I1;-J1;-J2;"Z;Sym;-J1;-J2;"Z,TAP,(
    DIA(I1,I2,-J1,J1,-J2,J2,"Z,"Z) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE4(I1,K1,K3,K5,*,MU,*,L1,*,L3,*,L5)*
   VE4(I2,K2,K4,K6,*,NU,*,L2,*,L4,*,L6)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
*yep
Id,NOM(PL,M~)=FP(1,M)-2*PDLE*FP(2,M)*E
   -LEDLE*E**2*FP(2,M)+4*PDLE**2*E**2*FP(3,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AAWFH=TOPH("A,"A)
TOPO{}
WORK{AAWFH}
Print AAWF
*begin
Write aawcomm
*end

C RO-parameter 8. Two-loop self-energy diagrams. A-W wave-function.

Oldnew i=I
Common AWWF
P ninput
Read Roblocks.e
VERT{,,,~,~}
S EI=2,NP1,TRN
V QL,PX,QX
X KROM(K1,K2)=DK(K1,5)*DK(K2,7)+DK(K1,7)*DK(K2,5)
X NUM(K1,K2)=1.-0.5*DK(K1,K2)
X NUM3(K1,K2,K3)=1-0.5*DK(K1,K2)-0.5*DK(K1,K3)-0.5*DK(K2,K3)
     +2/3*DK(K1,K2)*DK(K1,K3)
X KUM(K1)=1-DK(4,K1)
X ZUM(K1,K2,K3,K4,K5)=1-KUM(K1)*KUM(K2)*KUM(K3)*KUM(K4)*KUM(K5)
*fix
Z AWWF=0
Nprint AWWF
*next
BLOCK WORK{AWWFA}
P ninput
PROJ{,,~,}
F21F51{}
Id,Count,1,SM,1
*yep
Id,FSC(N~,M~)=F(N,M)*M**N*M**N/M**4
F1t5{}
Id,EP=0
*yep
NEXP{}
Id,EP=0
B EP,I,PI2,TIPI2,LE2
Id,Count,1,SM,1
Id,LG(SM,M~)=LG(SM)-LG(M)
Al,LG(M0,M~)=LG(M0)-LG(M)
Al,LG(M,M0~)=LG(M)-LG(M0)
Id,Multi,M0**2=M**2/C**2
Al,Multi,M0**-2=C**2/M**2
Al,Multi,PI**4=-0.25*TIPI2**2
Id,Commu,LG
Keep 'AWWFA'
*next
Z AWWF=AWWF+'AWWFA'
Nprint AWWF
B EP,I,PI2,TIPI2,LE2
ENDBLOCK
BLOCK TOPO{}
Id,TOPA(I1~,I2~)=
   DS(I1;J1;J2;Sym;J1;J2;TAP,(
     DS(-J1;J5;"Z;TAP,(
       DS(-J5;I2;-J4;TAP,(
   DIA(I1,I2,J1,-J1,J5,-J5,"Z,"Z,J2,-J2,J4,-J4) )) )) ))
Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K7,*,MU,LE,*,L1,P,*,L7,-PL)*
   VE3(K2,K3,K5,*,L2,-P,*,L3,-Q,*,L5,K)*
   VE3(K4,I2,K0,*,L4,Q,*,NU,-LE,*,L0,-QL)*
   VE3(K6,K8,K9,*,L6,-K,*,L8,PL,*,L9,QL)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*
   PROP(K7,K8,*,L7,PL,*,L8,PL)*
   PROP(K9,K0,*,L9,QL,*,L0,QL)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PXDPX+2*PXDLE*E*(1-X)+LEDLE*E**2/3
Al,Dotpr,PL(MU~)=PX(MU)+LE(MU)*(1-X)*E
Al,PL(MU~)=PX(MU)+LE(MU)*(1-X)*E
Id,QLDQL=QXDQX-2*QXDLE*E*(1-X)+LEDLE*E**2/3
Al,Dotpr,QL(MU~)=QX(MU)-LE(MU)*(1-X)*E
Al,QL(MU~)=QX(MU)-LE(MU)*(1-X)*E
Id,PDP=PXDPX-2*X*PXDLE*E+LEDLE*E**2/3
Al,Dotpr,P(MU~)=PX(MU)-X*LE(MU)*E
Al,P(MU~)=PX(MU)-X*LE(MU)*E
Id,QDQ=QXDQX+2*X*QXDLE*E+LEDLE*E**2/3
Al,Dotpr,Q(MU~)=QX(MU)+X*LE(MU)*E
Al,Q(MU~)=QX(MU)+X*LE(MU)*E
Id,PXDPX=PDP
Al,Dotpr,PX(MU~)=P(MU)
Al,PX(MU~)=P(MU)
Id,QXDQX=QDQ
Al,Dotpr,QX(MU~)=Q(MU)
Al,QX(MU~)=Q(MU)
*yep
Id,Adiso,NOM(P,M~)*NOM(PL,M~)=FP(2,M)-1/3*LEDLE*FP(3,M)*E**2
Id,Adiso,NOM(Q,M~)*NOM(QL,M~)=FQ(2,M)-4*QDLE*(X-Y)*FQ(3,M)*E
   -2/3*LEDLE*FQ(3,M)*E**2+2*QDLE**2*FQ(4,M)*E**2
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,X**N~=1/(N+1)
Al,Y**N~=1/(N+1)
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AWWFA=TOPA("A,"W)
TOPO{}
WORK{AWWFA}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPAP(I1~,I2~)=
   DS(I1;J1;J2;Sym;J1;J2;TAP,(
     DS(-J1;J3;"Z;TAP,(
       DS("Z;I2;-J4;TAP,(
   DIA(I1,I2,J1,-J1,"Z,"Z,J3,-J3,J2,-J2,J4,-J4) )) )) ))
Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K7,*,MU,LE,*,L1,P,*,L7,-PL)*
   VE3(K2,K3,K5,*,L2,-P,*,L3,-Q,*,L5,K)*
   VE3(K4,I2,K0,*,L4,Q,*,NU,-LE,*,L0,-QL)*
   VE3(K6,K8,K9,*,L6,-K,*,L8,PL,*,L9,QL)*
   PROP(K1,K2,*,L1,P,*,L2,P)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*
   PROP(K7,K8,*,L7,PL,*,L8,PL)*
   PROP(K9,K0,*,L9,QL,*,L0,QL)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
Id,QLDQL=QDQ-2*QDLE*E+LEDLE*E**2
Al,Dotpr,QL(MU~)=Q(MU)-LE(MU)*E
Al,QL(MU~)=Q(MU)-LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(PL,M~)=FP(2,M)-2*PDLE*E*FP(3,M)
   -LEDLE*E**2*FP(3,M)+4*PDLE**2*E**2*FP(4,M)
Id,NOM(QL,M~)=FQ(1,M)+2*QDLE*E*FQ(2,M)-LEDLE*E**2*FQ(2,M)
   +4*QDLE**2*E**2*FQ(3,M)
Al,NOM(K,M~)=FK(1,M)
Al,NOM(Q,M~)=FQ(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
Id,Adiso,FQ(1,SM)*FQ(N~,M0)=DIFF**-N*FQ(1,SM)*(-1)**N
   *ATEL9
Id,DIFF**N~=SM**N*SM**N*(1-N*M0**2/SM**2)
Id,Count,1,SM,1,P,1,Q,1,K,1,ATEL9,2
Id,Numer,ATEL9,1.
ENDBLOCK
Z AWWFA=TOPAP("A,"W)
TOPO{}
WORK{AWWFA}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPB(I1~,I2~)=
   DS(I1;-J1;-J2;TAP,(
     DS(J2;"Z;-J4;TAP,( DC("P,TAP,-1,"Z,J4)*
       DS(J1;I2;J5,TAP,(
   DIA(I1,I2,-J1,J1,-J2,J2,-J5,J5,"Z,"Z,J4,-J4) ))) )))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~,K9~,K0~)=
   VE3(I1,K1,K3,*,MU,-LE,*,L1,PL,*,L3,-P)*
   VE3(K2,I2,K6,*,L2,-PL,*,NU,LE,*,L6,P)*
   VE3(K4,K7,K0,*,L4,P,*,L7,-K,*,L0,Q)*
   VE3(K5,K8,K9,*,L5,-P,*,L8,K,*,L9,-Q)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,P,*,L4,P)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,K,*,L8,K)*
   PROP(K9,K0,*,L9,Q,*,L0,Q)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
   FP(3,M)-2*PDLE*FP(4,M)*E
   -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AWWFB=TOPB("A,"W)
TOPO{}
WORK{AWWFB}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPE(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J2;-J4;J4;J3;Sym;-J4;J4;TAP,(
     DIA(I1,I2,-J1,J1,-J4,J4,-J2,J2,J3,-J3) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,LE,*,L1,-PL,*,L5,P)*
   VE3(K2,I2,K8,*,L2,PL,*,NU,-LE,*,L8,-P)*
   VE4(K6,K3,K4,K7,*,L6,*,L3,*,L4,*,L7)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,P,*,L8,P)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
   FP(3,M)-2*PDLE*FP(4,M)*E
   -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Al,NOM(Q,M~)=FQ(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AWWFE=TOPE("A,"W)
TOPO{}
WORK{AWWFE}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPF(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS("Z;J2;J4;TAP,( DC("P,TAP,-1,"Z,J4)*
   DIA(I1,I2,-J1,J1,"Z,"Z,-J2,J2,J4,-J4) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,-LE,*,L1,PL,*,L5,-P)*
   VE4(K2,I2,K4,K8,*,L2,*,NU,*,L4,*,L8)*
   VE3(K3,K6,K7,*,L3,-K,*,L6,P,*,L7,Q)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,K,*,L4,K)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,Q,*,L8,Q)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,PLDPL=PDP+2*PDLE+LEDLE*E**2
Al,Dotpr,PL(MU~)=P(MU)+LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(PL,M~)=FP(2,M)-2*PDLE*FP(3,M)*E
   -LEDLE*E**2*FP(3,M)+4*PDLE**2*E**2*FP(4,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AWWFF=TOPF("A,"W)+TOPF("W,"A)
TOPO{}
WORK{AWWFF}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPFP(I1~,I2~)=
    DS(I2;-J1;"Z;TAP,(
      DS(J1;I1;-J3;-J4;TAP,(
   DIA(I1,I2,-J1,J1,J3,-J3,"Z,"Z,J4,-J4) )) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I2,K1,K5,*,NU,-LE,*,L1,QL,*,L5,-Q)*
   VE4(K2,I1,K4,K8,*,L2,*,MU,*,L4,*,L8)*
   VE3(K3,K6,K7,*,L3,-K,*,L6,Q,*,L7,P)*
   PROP(K1,K2,*,L1,QL,*,L2,QL)*
   PROP(K3,K4,*,L3,K,*,L4,K)*
   PROP(K5,K6,*,L5,Q,*,L6,Q)*
   PROP(K7,K8,*,L7,P,*,L8,P)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,QDLE=QDLE*E
Al,KDLE=KDLE*E
Al,PLDLE=PLDLE*E
Al,QLDLE=QLDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Id,QLDQL=QDQ+2*QDLE+LEDLE*E**2
Al,Dotpr,QL(MU~)=Q(MU)+LE(MU)*E
Al,QL(MU~)=Q(MU)+LE(MU)*E
*yep
Id,NOM(QL,M~)=FQ(1,M)-2*QDLE*E*FQ(2,M)
   -LEDLE*E**2*FQ(2,M)+4*QDLE**2*E**2*FQ(3,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(P,M~)=FP(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
Id,Adiso,FQ(1,SM)*FQ(N~,M0)=DIFF**-N*FQ(1,SM)*(-1)**N
   *ATEL9
Id,DIFF**N~=SM**N*SM**N*(1-N*M0**2/SM**2)
Id,Count,1,SM,1,P,1,Q,1,K,1,ATEL9,2
Id,Numer,ATEL9,1.
ENDBLOCK
Z AWWFF=TOPFP("A,"W)
TOPO{}
WORK{AWWFF}
*next
BDELETE TOPO
BLOCK TOPO{}
Id,TOPH(I1~,I2~)=
    DS(I1;-J1;-J2;"Z;Sym;-J1;-J2;"Z,TAP,(
    DIA(I1,I2,-J1,J1,-J2,J2,"Z,"Z) ))

Id,Anti,TAP

Id,DIA(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE4(I1,K1,K3,K5,*,MU,*,L1,*,L3,*,L5)*
   VE4(I2,K2,K4,K6,*,NU,*,L2,*,L4,*,L6)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,Q,*,L4,Q)*
   PROP(K5,K6,*,L5,K,*,L6,K)*XX
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
*yep
Id,NOM(PL,M~)=FP(1,M)-2*PDLE*FP(2,M)*E
   -LEDLE*E**2*FP(2,M)+4*PDLE**2*E**2*FP(3,M)
Al,NOM(Q,M~)=FQ(1,M)
Al,NOM(K,M~)=FK(1,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
ENDBLOCK
Z AWWFH=TOPH("A,"W)
TOPO{}
WORK{AWWFH}
Print AWWF
*begin
Write awwcomm
*end

C RO-parameter 9. Subtractions for A-A and A-W wave-functions.

C SUBTRACTIONS, A-A AND A-W WAVEFUNCTIONS.
C ENTER RESULTS FROM TWO-LOOP CALCULATIONS, AAWF AND AWWF.
C DCDC CPU time 14.7 SEC.

Oldnew i=I
Enter aawcomm
Enter awwcomm
P ninput
Read Roblocks.e
VERT{,,~,~,~}
SVERT{,,~}
X NUM(K1,K2)=1-0.5*DK(K1,K2)
*fix
BLOCK WORK{}
B E1,EZF,ET,EP,I,PI2,TIPI2,LE2
Id,Compo,<X>,VE4,VE3,PROP
Id,Compo,<SS>,CONT
Id,Adiso,CONT(S~)*CONT(C~)=S/EP+C/EP
Al,CONT(S~)=S/EP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,ZERO**2=0
Id,PDLE=PDLE*E
Al,LEDLE=LEDLE*E**2
Al,PDPL=PDP+PDLE*E
Al,PLDLE=PDLE*E+LEDLE*E**2
Al,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,LE(MU~)=LE(MU)*E
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
   FP(3,M)-2*PDLE*FP(4,M)*E
   -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Al,Adiso,NOM(P,M~)*NOM(PL,M~)=
   FP(2,M)-2*PDLE*FP(3,M)*E
   -LEDLE*E**2*FP(3,M)+4*PDLE**2*E**2*FP(4,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
PROJ{,,~,~}
Id,FSC(N~,M~)=F(N,M)*M**N*M**N/M**4
F1t5{}
*yep
CVERT{,~,~}
SCVERT{,~,~}
Id,ZERO=0.
Id,Count,1,SM,1,E1,2,E2,2,ET,2,EZF,2
Id,C2MS2=1-2*S**2
E1EZF{,,~,~,~}
Id,Count,1,SM,1,ET,2,E1F,2,EZF,2
Id,EP=0
*yep
E1EZF{~,~,,,}
Id,Count,1,SM,1
Id,EP=0
*yep
NEXP{}
Id,EP=0
B EP,I,PI2,TIPI2,LE2
Id,C**-2*S**-4=1/S**4+1/S**2+1/C**2
Al,C**-2*S**-2=1/S**2+1/C**2
Id,LG(SM,M~)=LG(SM)-LG(M)
Al,LG(M0,M~)=LG(M0)-LG(M)
Al,LG(M,M0~)=LG(M)-LG(M0)
Id,Multi,M0**2=M**2/C**2
Al,PI**4=-0.25*TIPI2**2
Al,PI**2=-0.5*TIPI2*I
Id,Commu,LG
Id,C**2=1-S**2
ENDBLOCK
BLOCK SELF{}
Id,SELF(I1~,I2~)=
    DS(I1;J1;J2;Sym;J1;J2,TAP,(
    DIB(I1,J1,-J1,J2,-J2,I2) ))
  + DS(I1;J4;-J5;TAP,(
      DS("N;J5;-J6;TAP,(
    DID(I1,I2,"N,J4,-J5,J5,-J6,J6,-J4) )) ))

Id,Anti,TAP

Id,DIB(I1~,K1~,K2~,K3~,K4~,I2~)=
   VE3(I1,K1,K3,*,MU,LE,*,L1,-PL,*,L3,P)*
   VE3(K2,I2,K4,*,L2,PL,*,NU,-LE,*,L4,-P)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K3,K4,*,L3,P,*,L4,P)
   *XX
  *CONT(I1,K1,K3,/,"K)*CONT(K2,I2,K4,/,"K)
Al,DID(I1~,I2~,I3~,K1~,K2~,K3~,K4~,K5~,K6~)=
   VE3(I1,K1,K2,*,MU,-LE,*,L1,PL,*,L2,-P)*
   VE3(I3,K3,K4,*,AL,K,*,L3,P,*,L4,-P)*
   VE3(I2,K5,K6,*,NU,LE,*,L5,P,*,L6,-PL)*
   PROP(K6,K1,*,L6,PL,*,L1,PL)*
   PROP(K2,K3,*,L2,P,*,L3,P)*
   PROP(K4,K5,*,L4,P,*,L5,P)
   *XX  /EP
ENDBLOCK
P input
Z AAWFC=SELF("A,"A)
P ninput
SELF{}
WORK{}
Keep AAWFC
*next
P input
Z AWWFC=SELF("A,"W)
P ninput
SELF{}
WORK{}
Keep AAWFC,AWWFC
*next
P input
B EP,I,PI2,TIPI2,LE2
Z TAAWF=AAWF-AAWFC
Z TAWWF=AWWF-AWWFC
*end

C RO-parameter 10. Tadpoles in A-A wave-function.

C A-A TWO-LOOP WAVE-FUNCTION. TADPOLE INSERTIONS.
C THERE ARE MORE DIAGRAMS INVOLVING TADPOLES, NAMELY
C WITH ONE 4-VERTEX AND ONE 3-VERTEX WHERE ONE OF THE
C LINES OF THE 4-VERTEX CONNECTS TO A TADPOLE.
C THESE DIAGRAMS CANCEL OUT IF ONE SUBTRACTS THE COUNTERDIAGRAMS
C CONTAINING THE SAME TYPE OF DIAGRAMS, BUT THEY WERE COMPUTED
C TO SEE IF WITH THIS ADDITION THE TWO-LOOP DIAGRAMS WHERE
C GAUGE INVARIANT BY THEMSELVES, WHICH MUST BE.
C CDC CPU TIME 2.5 SEC.

Oldnew i=I
P ninput
Read Roblocks.e
C P input
VERT{,,~,,}
F FSC
S NP1,TRN
*fix
Z A0A0=0
Keep A0A0
Nprint A0A0
*next
P ninput
BLOCK WORK{A0A0A}
P ninput
Id,Compo,<X>,VE4,VE3,PROP
Id,VE4(AA~,L1~,L2~,L3~,L4~)=AA(L1,L2,L3,L4)
Al,VE3(AA~,MU~,P0~,L2~,Q~,L1~,P~)=
       AA(MU,P0,L2,Q,L1,P)
Al,PROP(AA~,L4~,Q~,L3~,P~)=AA(L4,L3,Q)
Id,Commu,NOM
Id,PDLE=PDLE*E
Al,LEDLE=E**2*LEDLE
Al,LE(MU~)=LE(MU)*E
Al,PDPL=PDP+PDLE*E
Al,PLDLE=PDLE*E+LEDLE*E**2
Al,PLDPL=PDP+2*PDLE*E+LEDLE*E**2
Al,PL(MU~)=P(MU)+LE(MU)*E
*yep
Id,Adiso,NOM(P,M~)*NOM(P,M~)*NOM(PL,M~)=
  FP(3,M)-2*PDLE*FP(4,M)*E
  -LEDLE*E**2*FP(4,M)+4*PDLE**2*E**2*FP(5,M)
Id,E**1=0
Al,XX*E**2=1
Al,XX=0
PROJ{,,~,~}
Id,FSC(N~,M~)=F(N,M)*M**N*M**N/M**4
F1t5{}
Id,EP=0
*yep
NEXP{}
Id,EP=0
B EP,I,PI2,TIPI2,LE2,TADPO,TADGH
Id,Count,1,SM,1,ET,2
Id,LG(SM,M~)=LG(SM)-LG(M)
Al,LG(M0,M~)=LG(M0)-LG(M)
Al,LG(M,M0~)=LG(M)-LG(M0)
Id,Multi,M0**2=M**2/C**2
Al,PI**4=-0.25*TIPI2**2
Id,Commu,LG
Keep A0A0,'A0A0A'
*next
Z A0A0=A0A0+'A0A0A'
Nprint A0A0
Keep A0A0
B EP,I,PI2,TIPI2,LE2,TADPO,TADGH
ENDBLOCK
BLOCK TOPO{}
P ninput
Id,TOPE(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J1;I2;-J3;TAP,( DC("F,TFE,0,J1)*
     DIB(I1,I2,-J1,J1,"Z,"Z,-J2,J2,J3,-J3) )) ))

Id,Anti,TAP

Id,DIB(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,LE,*,L1,-PL,*,L5,P)*
   VE3(K2,I2,K8,*,L2,PL,*,NU,-LE,*,L8,-P)*
   VE3(K6,K7,"Z,*,L6,-P,*,L7,P,*,L9,P0)/SM**2*
   M*SM**2*ET/EP*(-1)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,P,*,L8,P)*XX*TADPO
ENDBLOCK
P input
Z A0A0E=TOPE("A,"A)
TOPO{}
WORK{A0A0E}
C PRINT OUTPUT
C PRINT A0A0
*yep
E1EZF{~,~,,~,~}
Id,EP=0
Id,Count,1,SM,1,ET,2
Id,PI**2=-0.5*I*TIPI2
*next
BLOCK TOPOP{}
P ninput
Id,TOPE(I1~,I2~)=
    DS(I1;-J1;-J2;TAP,(
      DS(J1;I2;-J3;TAP,( -DC("F_,TFE,0,J1)*
     DIB(I1,I2,-J1,J1,"Z,"Z,-J2,J2,J3,-J3) )) ))

Id,Anti,TAP

Id,DIB(I1~,I2~,K1~,K2~,K3~,K4~,K5~,K6~,K7~,K8~)=
   VE3(I1,K1,K5,*,MU,LE,*,L1,-PL,*,L5,P)*
   VE3(K2,I2,K8,*,L2,PL,*,NU,-LE,*,L8,-P)*
   VE3(K6,K7,"Z,*,L6,-P,*,L7,P,*,L9,P0)/SM**2*
   M*SM**2*ET/EP*(-1)*
   PROP(K1,K2,*,L1,PL,*,L2,PL)*
   PROP(K5,K6,*,L5,P,*,L6,P)*
   PROP(K7,K8,*,L7,P,*,L8,P)*XX*TADGH
ENDBLOCK
Z A0A0E=TOPE("A,"A)
TOPOP{}
WORK{A0A0E}
C PRINT OUTPUT
Print A0A0
*yep
E1EZF{~,~,,~,~}
Id,EP=0
Id,Count,1,SM,1,ET,2
Id,PI**2=-0.5*I*TIPI2
C PRINT OUTPUT
*yep
Id,TADGH=TADPO
*end

C RO-parameter 11. Diagrams with tadpole insertions.

C DIAGRAMS WITH ONE 4-VERTEX WITH TADPOLE AND ONE 3-VERTEX.
C A-A WAVE-FUNCTION.
C REST REFERS TO THE RESULT OF THE PREVIOUS PROGRAM,
C SELF-ENERGY DIAGRAMS WITH TADPOLE INSERTION,
C AND THE D(MU,NU) PART OF THE A-A WAVE-FUNCTION CALCULATION.
C CDC CPU time 1 SEC.

P ninput
Read Roblocks.e
C P input
Oldnew,i=I
I MU=N,NU=N
S M,SM,LE2
B EP,TIPI2
F LG,F
V LE
Z XX=4*0.5*S**2*M*LE2*(-EP/N*F(3,M)-4/N*M**2*F(4,M))
    *(-M*ET/EP)
   + REST
Id,N**-1=1/4-EP/16+EP**2/64
F1t5{}
E1EZF{~,~,,~,~}
Id,EP=0
Al,PI**2=-0.5*I*TIPI2
Id,Count,2,SM,1,REST,2
P output
*yep
Id,REST=TIPI2**2*SM**2/M**2*S**2*LE2*(
     (1/16 + 21/16)/EP -1/6 - 37/48
    +(1/16 + 5/8)*LG(M)
    +11/16*LG(SM) )
*end

C RO-parameter 12. Counter-term Lagrangian for the standard model.

C COUNTERLAGRANGIAN. TWO SCHOONSCHIP PROGRAMS, THE FIRST
C TO PRODUCE THE REGULAR ONE-LOOP COUNTERTERMS, THE SECOND
C TO PRODUCE THE QUADRATIC TERMS ARISING FROM THE ONE-LOOP
C COUNTERTERMS.
C CDC CPU time 10 SEC.

Common DELL
*fix
P brackets
S X,M,SM,AL,BET,C,S,E=3
S GG,AM,AN,AMN,AMM
    ,F3,F3M,FP,FMP,FM,FMM
    ,WMNP,WMMP,WMP,WNP
    ,WMNM,WMMM,WMM,WNM
    ,WMN0,WMM0,WM0,WN0,Z,ZM
B GG,AM,AN,AMN,AMM
    ,F3,F3M,FP,FMP,FM,FMM
    ,WMNP,WMMP,WMP,WNP
    ,WMNM,WMMM,WMM,WNM
    ,WMN0,WMM0,WM0,WN0,Z,ZM
Z DELL = (HAND + WMMP*WMMM - M*WMMP*FM - M*WMMM*FP
         + M**2*FM*FP + 0.5*WMM0**2 - M/C*WMM0*F3
         + 0.5*M**2/C**2*F3**2 + 0.5*AMM**2 )*X
Id  HAND =
      - WMNP*WMNM - M**2*WMP*WMM - 0.5*WMN0**2 - 0.5*M**2*C**-2
      *WM0**2 - 0.5*AMN**2 - FMP*FMM - M**2*FP*FM - 0.5*F3M**2
      - 0.5*M**2*C**-2*F3**2 - 0.5*ZM**2 - 0.5*SM**2*Z**2
   + GG*(-I*C*(WMN0*(WNP*WMM-WNM*WMP) - WM0*(WNP*WMNM-WNM*WMNP)
       + WN0*(WMP*WMNM-WMM*WMNP))
       - I*S*(AMN*(WNP*WMM-WNM*WMP) - AM*(WNP*WMNM-WNM*WMNP)
       + AN*(WMP*WMNM-WMM*WMNP))
     + GG*{-0.5*WMP*WMM*WNP*WNM + 0.5*WMP**2*WNM**2
       + C**2*WM0*(WMP*WN0*WNM-WM0*WNP*WNM)
       + S**2*AM*WNM*(WMP*AN-AM*WNP)
       + S*C*AM*(WN0*(WMP*WNM+WNP*WMM) - 2.*WM0*WNP*WNM)   } )
   + GG*(-AL*M*Z*(Z**2+F3**2+2.*FP*FM)
     + GG*{-0.125*AL*(Z**4+F3**4+4.*FP**2*FM**2+4.*F3**2*FP*FM
         + 4.*Z**2*FP*FM + 2.*F3**2*Z**2)   }
       - M*Z*WMP*WMM - 0.5*M*C**-2*Z*WM0**2
       - 0.5*I*(WMP*(F3*FMM-FM*F3M) - WMM*(F3*FMP-FP*F3M))
       + 0.5*(WMP*(Z*FMM-FM*ZM) + WMM*(Z*FMP-FP*ZM))
       + 0.5*C**-1*(WM0*(Z*F3M-F3*ZM))
       - I*S**2*C**-1*M*WM0*(WMP*FM-WMM*FP)
       + I*S*M*AM*(WMP*FM-WMM*FP)
       - I*(0.5*C**-1 - C)*WM0*(FP*FMM-FM*FMP)
       + I*S*AM*(FP*FMM-FM*FMP)
     + GG*{-0.25*WMP*WMM*(Z**2+F3**2+2.*FP*FM)
      - 0.125*C**-2*WM0**2*(Z**2+F3**2 + 2.*(2.*S**2-1.)**2*FP*FM)
      - S**2*AM**2*FP*FM
       - 0.5*S**2*C**-1*WM0*F3*(WMP*FM+WMM*FP)
       - 0.5*I*S**2/C*WM0*Z*(WMP*FM-WMM*FP)
       + 0.5*S*AM*F3*(WMP*FM+WMM*FP)
       + 0.5*I*S*AM*Z*(WMP*FM-WMM*FP)
       - S/C*(2.*C**2-1)*WM0*AM*FP*FM     } )
Id,WMNP=WMNP*(1+E*EC)
Al,WMMP=WMMP*(1+E*EC)
Al,WMNM=WMNM*(1+E*EC)
Al,WMMM=WMMM*(1+E*EC)
Al,WMP=WMP*(1+E*EC)
Al,WNP=WNP*(1+E*EC)
Al,WMM=WMM*(1+E*EC)
Al,WNM=WNM*(1+E*EC)
Al,WMN0=WMN0*(1+E*E0) + E*E0A*AMN
Al,WMM0=WMM0*(1+E*E0) + E*E0A*AMM
Al,WM0=WM0*(1+E*E0) + E*E0A*AM
Al,WN0=WN0*(1+E*E0) + E*E0A*AN
Al,AMN=AMN*(1+E*EA) + E*EA0*WMN0
Al,AMM=AMM*(1+E*EA) + E*EA0*WMM0
Al,AM=AM*(1+E*EA) + E*EA0*WM0
Al,AN=AN*(1+E*EA) + E*EA0*WN0
Id,FMP=FMP*(1+E*EFC)
Al,FP=FP*(1+E*EFC)
Al,FMM=FMM*(1+E*EFC)
Al,FM=FM*(1+E*EFC)
Al,F3M=F3M*(1+E*EF3)
Al,F3=F3*(1+E*EF3)
Al,ZM=ZM*(1+E*EZ)
Al,Z=Z*(1+E*EZ)+E*ETP
Id,EFC=EZ
Al,EF3=EZ
*yep
Id,GG=GG*(1+E*EG)
Al,AL=AL*(1+E*EAL)
Al,C=C*(1+E*ECO)
Al,Multi,C**-1=C**-1*(1-E*ECO)
Al,S=S*(1-E*ECO*C**2/S**2)
Al,Multi,S**-1=S**-1*(1+E*ECO*C**2/S**2)
Al,M=M*(1+E*EM)
Al,SM=SM*(1+E*ESM)
Nprint DELL
*next
B GG,AM,AN,AMN,AMM
    ,F3,F3M,FP,FMP,FM,FMM
    ,WMNP,WMMP,WMP,WNP
    ,WMNM,WMMM,WMM,WNM
    ,WMN0,WMM0,WM0,WN0,Z,ZM
Z DELP=DELL
Id,Multi,E**2=0
Id,X*E=1
Id,EAL=2*ESM-2*EM
Al,ETP=M*ET*GG**-1
Al,AL=0.25*SM**2/M**2
C E1=EM+0.5*ET, E2=EM-ESM
Id,EM=E1-0.5*ET
Al,ESM=E1-E2-0.5*ET
*yep
C PRINT OUTPUT
Id,Multi,S**2=1-C**2
Id  WMP**2*WNM**2=WNP**2*WMM**2
Id  WM0*WN0*WMM*WNP=WM0*WN0*WNM*WMP
Al  WM0*AN*WMM*WNP=WN0*AM*WNM*WMP
Al  WM0*AN*WMP*WNM=WN0*AM*WNP*WMM
Al  AM*AN*WMM*WNP=AM*AN*WNM*WMP
Al  WN0*AN*WMP*WMM=WM0*AM*WNP*WNM
Al  WN0**2*WMP*WMM=WM0**2*WNP*WNM
Al  AN**2*WMP*WMM=AM**2*WNP*WNM
Oldnew,G=GAM,WNM=VN,WMM=VM,WMMM=VMM,WMNM=VMN
Oldnew,WNP=UN,WMP=UM,WMMP=UMM,WMNP=UMN
Oldnew,FMM=HM,FM=H,FMP=GM,FP=G,F3=F,F3M=FM
B GG,AM,AN,AMN,AMM,F,FM,G,GM,H,HM,UMN,UMM
 ,UM,UN,VMN,VMM,VM,VN,WMN0,WMM0,WM0,WN0,Z,ZM
*yep
Id,EC=19/12
Al,E0=1/6+1.5*C**2-1/12/C**2
Al,E0A=-2*C*S
Al,EA=1.5*S**2
Al,EA0=5*S*C+S/C/6
Al,EZ=0.5+0.25/C**2+EZF
Al,EG=-43/12
Al,ECO=-S**2*(43-42*S**2)/12/C**2

C AL,E1=0.5/C**2-31/12+E1F
C AL,E2=-25/12+0.75/C**2-1.5*M**2/SM**2
C       -0.75*M**2/C**4/SM**2-0.75*SM**2/M**2
C       +E2F
C AL,ET=1.5*M**2/C**4/SM**2+0.25/C**2+0.5+3*M**2/SM**2
C     +0.75*SM**2/M**2
C     +ETF
C AL,EM=3/C**2/8-17/6-1.5*M**2/SM**2-0.75*M**2/C**4/SM**2
C     -3*SM**2/M**2/8
C AL,ESM=-0.75-3/C**2/8+3*SM**2/M**2/8

Al,AL=0.25*SM**2/M**2
Id,Multi,S**2=1-C**2
*begin
C COUNTER LAGRANGIAN, QUADRATIC TERMS.
Oldnew,GAM=G
Names DELL
S X,M,SM,AL,BET,C,S,E=3
S GG,AM,AN,AMN,AMM
    ,F3,F3M,FP,FMP,FM,FMM
    ,WMNP,WMMP,WMP,WNP
    ,WMNM,WMMM,WMM,WNM
    ,WMN0,WMM0,WM0,WN0,Z,ZM
B GG,AM,AN,AMN,AMM
    ,F3,F3M,FP,FMP,FM,FMM
    ,WMNP,WMMP,WMP,WNP
    ,WMNM,WMMM,WMM,WNM
    ,WMN0,WMM0,WM0,WN0,Z,ZM
Z DEPP=DELL
Id,X*E**2=1
Al,E**1=0
Id,EAL=2*ESM-2*EM
Al,ETP=M*ET*GG**-1
Al,AL=0.25*SM**2/M**2
C E1=EM+0.5*ET, E2=EM-ESM
Id,EM=E1-0.5*ET
Al,ESM=E1-E2-0.5*ET
*yep
C PRINT OUTPUT
Id,Multi,S**2=1-C**2
Id  WMP**2*WNM**2=WNP**2*WMM**2
Id  WM0*WN0*WMM*WNP=WM0*WN0*WNM*WMP
Al  WM0*AN*WMM*WNP=WN0*AM*WNM*WMP
Al  WM0*AN*WMP*WNM=WN0*AM*WNP*WMM
Al  AM*AN*WMM*WNP=AM*AN*WNM*WMP
Al  WN0*AN*WMP*WMM=WM0*AM*WNP*WNM
Al  WN0**2*WMP*WMM=WM0**2*WNP*WNM
Al  AN**2*WMP*WMM=AM**2*WNP*WNM
Oldnew,G=GAM,WNM=VN,WMM=VM,WMMM=VMM,WMNM=VMN
Oldnew,WNP=UN,WMP=UM,WMMP=UMM,WMNP=UMN
Oldnew,FMM=HM,FM=H,FMP=GM,FP=G,F3=F,F3M=FM
B GG,AM,AN,AMN,AMM,F,FM,G,GM,H,HM,UMN,UMM
 ,UM,UN,VMN,VMM,VM,VN,WMN0,WMM0,WM0,WN0,Z,ZM
Id,F=0
Al,FM=0
Al,Z=0
Al,ZM=0
Al,G=0
Al,GM=0
Al,H=0
Al,HM=0
Al,GG=0
Al,Multi,GG**-1=0
*yep
Id,EC=19/12
Al,E0=1/6+1.5*C**2-1/12/C**2
Al,E0A=-2*C*S
Al,EA=1.5*S**2
Al,EA0=5*S*C+S/C/6
Al,EZ=0.5+0.25/C**2+EZF
Al,EG=-43/12
Al,ECO=-S**2*(43-42*S**2)/12/C**2
Al,E1=0.5/C**2-31/12+E1F
Al,E2=-25/12+0.75/C**2-1.5*M**2/SM**2
      -0.75*M**2/C**4/SM**2-0.75*SM**2/M**2
      +E2F
C AL,ET=1.5*M**2/C**4/SM**2+0.25/C**2+0.5+3*M**2/SM**2
C     +0.75*SM**2/M**2
C     +ETF
C AL,EM=3/C**2/8-17/6-1.5*M**2/SM**2-0.75*M**2/C**4/SM**2
C     -3*SM**2/M**2/8
C AL,ESM=-0.75-3/C**2/8+3*SM**2/M**2/8
Al,AL=0.25*SM**2/M**2
C ID,COUNT,1,SM,1,E1F,2,E2F,2,EZF,2,ET,2,X,2
Id,Multi,S**2=1-C**2
*end

C RO-parameter 13. Counter terms for the Ghost Lagrangian, standard model.

C GHOST COUNTER-LAGRANGIAN.
C LAGRANGIAN WITH COUNTERTERMS GENERATED BY RENORMALIZED GAUGE
C TRANSFORMATIONS.
C INSTRUCTIONS FOR DIAGONILIZATION ARE GIVEN NEAR THE *END CARD.
C FERMIONS DO NOT CONTRIBUTE TO GHOST INFINITIES.
C A SECOND PROGRAM INDICATES AND CHECKS THE IDENTITIES
C RESULTING FROM THIS REQUIREMENT.

S XX,M,MP,LP,LPP,LNPP,LNP,LM,LMP,LNMP,LNM,L0,L0P,LN0P,LN0
  ,LA,LAP,LNA,LNAP
S  E=2
Oldnew,G=GAM,DF=DFREZ
B GG,AN,F,G,H,O,ON,P,PN,Q,QN,R,RN,SN,T,TN,UN,VN,WN
  ,X,XN,Y,YN,Z
Z GHOST=XX*( XN*DUN + M*X*DG
          +ON*DVN+M*O*DH
          +QN*DWN+M*Q*DF/C
          +SN*DAN)
Id,DUN=(1-E*EC)*(I*BP*LPP*(CP*WNP+SP*ANP)
        -I*BP*(CP*L0P+SP*LAP)*UNP-LNPP)
Al,DVN=(1-E*EC)*(-I*BP*LMP*(CP*WNP+SP*ANP)
        +I*BP*(CP*L0P+SP*LAP)*VNP-LNMP)
Al,DWN=(1-E*E0)*(-I*BP*CP*LPP*VNP
                 +I*BP*CP*LMP*UNP-LN0P)
        - E*E0A*(-I*GG*S*LP*VN+I*GG*S*LM*UN-LNA)
Al,DAN=(1-E*EA)*(-I*BP*SP*LPP*VNP
                 +I*BP*SP*LMP*UNP-LNAP)
        - E*EA0*(-I*GG*C*LP*VN+I*GG*C*LM*UN-LN0)
Al,DG=(1-E*EZ)*(0.5*I*BP*LPP*FP
                -0.5*I*BP*((2*CP**2-1)*L0P/CP+2*SP*LAP)*GP
                -0.5*BP*ZP*LPP-MP*LPP)
Al,DH=(1-E*EZ)*(-0.5*I*BP*LMP*FP
                +0.5*BP*I*((2*CP**2-1)*L0P/CP+2*SP*LAP)*HP
                -0.5*BP*ZP*LMP-MP*LMP)
Al,DF=(1-E*EZ)*(-0.5*I*BP*(LPP*HP-LMP*GP)
                -0.5*BP*L0P*ZP/CP-MP*L0P/CP)
Al,DZ=(1-E*EZ)*(0.5*BP*(LPP*HP*LMP*GP)+0.5*BP*FP*L0P/CP)
Id,BP=GG*(1+E*EG)
Al,MP=M*(1+E*EM)
Al,LPP=LP*(1+E*ELC)
Al,LMP=LM*(1+E*ELC)
Al,CP=C*(1+E*ECO)
Al,Multi,CP**-1=(1-E*ECO)/C
Al,SP=S*(1-E*ECO*C**2/S**2)
Al,WNP=(1+E*E0)*WN+E*E0A*AN
Al,ANP=(1+E*EA)*AN+E*EA0*WN
Al,L0P=(1+E*EL0)*L0+E*EL0A*LA
Al,LAP=(1+E*ELA)*LA+E*ELA0*L0
Al,LN0P=(1+E*EL0)*LN0+E*EL0A*LNA
Al,LNAP=(1+E*ELA)*LNA+E*ELA0*LN0
Al,LNPP=(1+E*ELC)*LNP
Al,LNMP=(1+E*ELC)*LNM
Id,ZP=(1+E*EZ)*Z+E*M*ET/GG
Al,GP=(1+E*EZ)*G
Al,HP=(1+E*EZ)*H
Al,FP=(1+E*EZ)*F
Al,UNP=(1+E*EC)*UN
Al,VNP=(1+E*EC)*VN
Id,XX*E=1
Id,L0=R
Al,LN0=RN
Al,LA=T
Al,LNA=TN
Al,LP=Y
Al,LNP=YN
Al,LM=P
Al,LNM=PN
Id,EM=E1-0.5*ET
Al,ESM=E1-E2-0.5*ET
Id,Multi,S**2=1-C**2
Keep GHOST
*next
B GG,AN,F,G,H,O,ON,P,PN,Q,QN,R,RN,SN,T,TN,UN,VN,WN
  ,X,XN,Y,YN,Z
Z GHO=GHOST
Id,EC=19/12
Al,E0=1/6+1.5*C**2-1/12/C**2
Al,E0A=-2*C*S
Al,EA=1.5*S**2
Al,EA0=5*S*C+S/C/6
Al,EZ=0.5+0.25/C**2+EZF
Al,ELC=31/12
Al,EL0=1/6+5*C**2/2-1/12/C**2
Al,ELA=2.5*S**2
Al,EL0A=-C*S
Al,ELA0=6*S*C+S/C/6
Al,EG=-43/12
Al,ECO=-S**2*(43-42*S**2)/12/C**2
C AL,ET=1.5*M**2/C**4/SM**2+0.25/C**2+0.5+3*M**2/SM**2
C     +0.75*SM**2/M**2
C AL,EM=3/C**2/8-17/6-1.5*M**2/SM**2-0.75*M**2/C**4/SM**2
C     -3*SM**2/M**2/8
C AL,ESM=-0.75-3/C**2/8+3*SM**2/M**2/8
Id,Multi,S**2=1-C**2
C PRINT OUTPUT
C *YEP
C PRINT INPUT
C C THE FOLLOWING DIAGOLINIZES THE QUADRATIC PART.
C ID,R=(1-S**2*EP)*R+C*S*T*EP
C AL,RN=(1-S**2*EP)*RN+C*S*TN*EP
C AL,T=-C*S*R*EP+(1-S**2*EP)*T
C AL,TN=-C*S*EP*RN+(1-S**2*EP)*TN
C AL,SN=SN+EP*SN-2*C*S*EP*QN
C AL,Q=Q+2*S**2*EP*Q
C AL,QN=QN+2*S**2*EP*QN
C ID,XX*EP=1
C ID,EP=0
C ID,MULTI,S**2=1-C**2
C PRINT OUTPUT
C *YEP
C C THE FOLLOWING REMOVES THE DIVERGENCIES OF THE QUADRATIC PART
C C BUT NOT OF THE MASS TERMS.
C ID,Q=Q*(1-EP)
C AL,QN=QN*(1-EP)
C AL,O=O*(1-EP)
C AL,ON=ON*(1-EP)
C AL,SN=SN*(1-EP)
C AL,X=X*(1-EP)
C AL,XN=XN*(1-EP)
C ID,XX*EP=1
C ID,EP=0
C ID,MULTI,S**2=1-C**2
Keep GHOST
*next
B GG,AN,F,G,H,O,ON,P,PN,Q,QN,R,RN,SN,T,TN,UN,VN,WN
  ,X,XN,Y,YN,Z
Z GHO=GHOST
Id,XX=0
*yep
C REQUIRING NO INFINITIES IN QUADRATIC PART.
Id,ELC=EC
Al,ELA=EA
Al,ELA0=EA0
Al,EL0A=E0A
Al,EL0=E0
P output
*yep
C REQUIRING NO INFINITIES IN VERTICES.
Id,EG=-EC
Al,E0A=0
Al,ECO=E0-EC
Al,E1=-EC+EZ
Al,EA0=2*C*EC/S-2*C*E0/S
Al,EA=-C**2*EC/S**2+C**2*E0/S**2+EC
*end

C RO-parameter 14. Rationalization.

C RATIONALIZATION.
P ninput
S EI=2,N,M,M0,SM
V P,Q,K
B A1,A2,A3,A4,B1,B2,B3,B4,B5
Z  XX= (A1*PDP + A2*PDP**2 + A3*PDP**3)
      *(B1*FP(1,M) + B2*FP(2,M) + B3*FP(3,M) + B4*FP(4,M) )
      *(1+T)
Id,T*PDP**K1~*FP(L1~,M~)=T*(-1)**K1*M**K1*M**K1*
  DS(IX,0,K1+(L1-1-K1)*DT(K1-L1+1),(M**-IX*M**-IX*FP(L1-IX,M)),
          (-(K1-IX+1)/IX) )
   +T*EI*(-1)**K1*(-1)**L1*M**K1*M**K1/M**L1/M**L1*
   DT(K1-L1)*DB(K1-1,K1-L1)* DS(IX2,0,K1-L1,
     (PDP**IX2/M**IX2/M**IX2),(-(K1-L1-IX2+1)/(K1-IX2)) )
Id,T*PDP**2=T*QDQ**2+T*KDK**2+T*2*QDQ*KDK+T*4/N*QDQ*KDK
Al,T*PDP=T*QDQ+T*KDK
Id,PDP**3*FP(1,M~)=EI*QDQ**2+EI*KDK**2+2*EI*QDQ*KDK+4/N*EI*QDQ*KDK
   -M**2*EI*QDQ-M**2*EI*KDK+EI*M**4-M**6*FP(1,M)
Al,PDP**3*FP(2,M~)=EI*KDK+EI*QDQ-2*EI*M**2
    +3*M**4*FP(1,M)-M**6*FP(2,M)
Id,2,PDP**2*FP(1,M~)=EI*QDQ+EI*KDK-EI*M**2+M**4*FP(1,M)
Id,3,PDP**N~*FP(4,M~)=PDP**N/PDP*FP(3,M)
    -PDP**N/PDP*M**2*FP(4,M)
Id,3,PDP**N~*FP(3,M~)=PDP**N/PDP*FP(2,M)
   -PDP**N/PDP*M**2*FP(3,M)
Id,PDP**2*FP(2,M~)=EI-2*M**2*FP(1,M)+M**4*FP(2,M)
Al,PDP*FP(2,M~)=FP(1,M)-M**2*FP(2,M)
Al,PDP*FP(1,M~)=EI-M**2*FP(1,M)
Id,FP(N~,M~)=AFP**N
P output
*yep
Id,T=-1
C Id,NUMER,T,-1.
*begin
C
C RATIONALIZATION.
C XA=X+A, XB=X+B, BA=B-A.
C EXPONENT OF XB POSITIVE, EXPONENT OF XA NEGATIVE.
C
Z XX=A1*XB**3*XA**-5 + A2*XB**3*XA**-4
   + A3*XB**3*XA**-1 + A4*XB**4*XA**-2
   + A5*XB**7*XA**-10 + A6*XB**10*XA**-5
   - A1*XBP**3*XAP**-5 - A2*XBP**3*XAP**-4
   - A3*XBP**3*XAP**-1 - A4*XBP**4*XAP**-2
   - A5*XBP**7*XAP**-10 - A6*XBP**10*XAP**-5
B A1,A2,A3,A4,A5,A6
Id,XB**M~*XA**N~=BA**M*XA**N*DS(M0,0,-1-N,(BA**-M0*XA**M0),
                                 ((M-M0+1)/M0) )
   + BA**M*BA**N*EI*DT(M+N)*DB(M-1,M+N)*DS(M1,0,M+N,
                    (XB**M1*BA**-M1),((M+N-M1+1)/(M-M1)) )
Id,XBP=XAP+BAP
*yep
Id,XAP=XBP-BAP
C ID,RATIO,XAP,XBP,BAP
P output
*yep
Id,XBP=XB
Al,BAP=BA
Al,Multi,XAP**-1=XA**-1
Id,EI=1
C Id,NUMER,EI,1.
*end

C RO-parameter 15. Epsilon expansion and projection operators.

S N,TRN,NP1,EP=3
Z TR1M1=2*N-N**2-N**3
Z X1=N**2*(N+1)*TRN
Z X2=N*(N+1)*TRN
Z X3=(N+1)*TRN
Z X4=N**3*TRN
Z X5=N**2*TRN
Z X6=N*TRN
Z X7=TRN
Z X8=1/N
Z X9=1/N**2
Z X0=N/OMN
Id,TRN=-1/72*(1.-R+R**2)
Id,N=4+EP
Al,R=54/72*EP+13/72*EP**2
Al,Multi,N**-1=(1-EP/4+EP**2/16)/4
Al,OMN**-1=-1/3*(1-EP/3+EP**2/9)
*next
C PROJECTION OPERATORS AND EP-EXPANSION.
S N,TRN,NP1,EP=3
I MU=N,NU=N,AL=N,BE=N,MUP=N,NUP=N
Z XX=(EE*D(MU,NU)*D(AL,BE)+FF*D(MU,AL)*D(NU,BE)
        +GG*D(MU,BE)*D(NU,AL) ) *FACT
Z YY=A1*AN/N + A2*AN**2/N**2 +A3*AOMN*N/OMN
C PROJECTION OPERATOR FOR EE AND FF+GG PARTS.
Id,FACT=TRN*(2*D(MU,NU)*D(AL,BE)-N*D(MU,AL)*D(NU,BE)
             -N*D(MU,BE)*D(NU,AL))*FGPRT
       +TRN*(-NP1*D(MU,NU)*D(AL,BE)+D(MU,AL)*D(NU,BE)
             +D(MU,BE)*D(NU,AL) )*EPART
Id,N**2*NP1*TRN =  - 10./9. + 1./18.*EP - 7./324.*EP**2
Al,N*NP1*TRN =  - 5./18. + 1./12.*EP - 17./648.*EP**2
Al,NP1*TRN =  - 5./72. + 11./288.*EP - 167./10368.*EP**2
Al,N**3*TRN =  - 8./9. - 1./162.*EP**2
Al,N**2*TRN =  - 2./9. + 1./18.*EP - 5./324.*EP**2
Al,N*TRN =  - 1./18. + 1./36.*EP - 7./648.*EP**2
Al,TRN =  - 1./72. + 1./96.*EP - 55./10368.*EP**2
Al,N*OMN** - 1 =  - 4/3 + EP/9 - EP**2/27
Al,N = 4 + EP
Al,N**-2 = 1/16 - EP/32 + 3*EP**2/256
Al,N**-1 = 1/4 - EP/16 + EP**2/64
Id,AN=4+EP
Al,AOMN=(-3-EP)*(1/4-EP/16+EP**2/64)
*end

C RO-parameter 16. Differentiating F111.

P stat
F LG
S SM,M,M0
X F1(M)=2*I*PI**2*M**2*(1/EP-0.5+0.5*LG(M)
   +EP*(1/4-LG(M)/4+LG(M)*LG(M)/8+PI**2/48))
X F2(M)=2*I*PI**2*(-1/EP-0.5*LG(M)
    -EP*(PI**2/48+LG(M)*LG(M)/8))
X F3(M)=I*PI**2/2/M**2+I*EP*PI**2/2/M**2/2*LG(M)
X F4(M)=I*PI**2/6/M**4
   -1/12*I*EP*PI**2/M**4*(1-LG(M))
X F5(M)=I*PI**2/M**6*(1/12-EP/16+EP*LG(M)/24)
X FX211(M,M0,SM)=
   +PI**4*(-1./2.-3.*SM**(-4)*M**2*M0**2-1./4.*SM**(-4)*M**4-9./4.*
   SM**(-4)*M0**4-SM**(-2)*M**2-SM**(-2)*M0**2-2.*EP**(-2)+EP**(-1)
   )
   +PI**6*(1./12.+2./3.*SM**(-4)*M**2*M0**2+1./3.*SM**(-4)*M0**4+1.
   /3.*SM**(-2)*M0**2)
   +LG(SM)*PI**4*(-4.*SM**(-4)*M**2*M0**2-1./2.*SM**(-4)*M**4-5./2.
   *SM**(-4)*M0**4-SM**(-2)*M**2-SM**(-2)*M0**2)
   +LG(SM)*LG(SM)*PI**4*(1./2.+2.*SM**(-4)*M**2*M0**2+SM**(-4)*M0**
   4+SM**(-2)*M0**2)
   -1./2.*LG(SM)*LG(M)*PI**4
   +LG(SM)*LG(M0)*PI**4*(-2.*SM**(-4)*M**2*M0**2-SM**(-4)*M0**4-SM*
   *(-2)*M0**2)
   +LG(M)*PI**4*(1.+3.*SM**(-4)*M**2*M0**2+1./2.*SM**(-4)*M**4+SM**
   (-2)*M**2-2.*EP**(-1))
   +LG(M)*LG(SM)*PI**4*(-1./2.-2.*SM**(-4)*M**2*M0**2-SM**(-4)*M0**
   4-SM**(-2)*M0**2)
   -1./2.*LG(M)*LG(M)*PI**4
   +LG(M)*LG(M0)*PI**4*(2.*SM**(-4)*M**2*M0**2+SM**(-4)*M0**4+SM**(
   -2)*M0**2)
   +LG(M0)*PI**4*(SM**(-4)*M**2*M0**2+5./2.*SM**(-4)*M0**4+SM**(-2)
   *M0**2)
X FX112(M,M0,SM)=
   +PI**4*(-1./2.+3.*SM**(-6)*M**2*M0**4+3.*SM**(-6)*M**4*M0**2+1./
   9.*SM**(-6)*M**6+1./9.*SM**(-6)*M0**6+SM**(-4)*M**2*M0**2+1./4.*
   SM**(-4)*M**4+1./4.*SM**(-4)*M0**4+SM**(-2)*M**2+SM**(-2)*M0**2-
   2.*EP**(-2)+EP**(-1))
   +PI**6*(-1./4.-2./3.*SM**(-6)*M**2*M0**4-2./3.*SM**(-6)*M**4*M0*
   *2-1./3.*SM**(-4)*M**2*M0**2)
   +LG(SM)*PI**4*(1.+5.*SM**(-6)*M**2*M0**4+5.*SM**(-6)*M**4*M0**2+
   1./3.*SM**(-6)*M**6+1./3.*SM**(-6)*M0**6+2.*SM**(-4)*M**2*M0**2+
   1./2.*SM**(-4)*M**4+1./2.*SM**(-4)*M0**4+SM**(-2)*M**2+SM**(-2)*
   M0**2-2.*EP**(-1))
   +LG(SM)*LG(SM)*PI**4*(-1.-2.*SM**(-6)*M**2*M0**4-2.*SM**(-6)*M**
   4*M0**2-SM**(-4)*M**2*M0**2)
   +LG(SM)*LG(M0)*PI**4*(2.*SM**(-6)*M**2*M0**4+2.*SM**(-6)*M**4*M0
   **2+SM**(-4)*M**2*M0**2)
   +LG(M)*PI**4*(-SM**(-6)*M**2*M0**4-4.*SM**(-6)*M**4*M0**2-1./3.*
   SM**(-6)*M**6-SM**(-4)*M**2*M0**2-1./2.*SM**(-4)*M**4-SM**(-2)*M
   **2)
   +LG(M)*LG(SM)*PI**4*(2.*SM**(-6)*M**2*M0**4+2.*SM**(-6)*M**4*M0*
   *2+SM**(-4)*M**2*M0**2)
   +LG(M)*LG(M0)*PI**4*(-2.*SM**(-6)*M**2*M0**4-2.*SM**(-6)*M**4*M0
   **2-SM**(-4)*M**2*M0**2)
   +LG(M0)*PI**4*(-4.*SM**(-6)*M**2*M0**4-SM**(-6)*M**4*M0**2-1./3.
   *SM**(-6)*M0**6-SM**(-4)*M**2*M0**2-1./2.*SM**(-4)*M0**4-SM**(-2
   )*M0**2)
X FX111(M,M0,SM)=
   +PI**4*(7./2.*SM**2+2.*SM**2*EP**(-2)-3.*SM**2*EP**(-1)+9./4.*SM
   **(-4)*M**2*M0**4+9./4.*SM**(-4)*M**4*M0**2+5./36.*SM**(-4)*M**6
   +5./36.*SM**(-4)*M0**6+SM**(-2)*M**2*M0**2+3./4.*SM**(-2)*M**4+3
   ./4.*SM**(-2)*M0**4+5./2.*M**2+2.*M**2*EP**(-2)-3.*M**2*EP**(-1)
   +5./2.*M0**2+2.*M0**2*EP**(-2)-3.*M0**2*EP**(-1))
   +PI**6*(1./4.*SM**2-1./3.*SM**(-4)*M**2*M0**4-1./3.*SM**(-4)*M**
   4*M0**2-1./3.*SM**(-2)*M**2*M0**2-1./12.*M**2-1./12.*M0**2)
   +LG(SM)*PI**4*(-3.*SM**2+2.*SM**2*EP**(-1)+3./2.*SM**(-4)*M**2*M
   0**4+3./2.*SM**(-4)*M**4*M0**2+1./6.*SM**(-4)*M**6+1./6.*SM**(-4
   )*M0**6+1./2.*SM**(-2)*M**4+1./2.*SM**(-2)*M0**4-M**2-M0**2)
   +LG(SM)*LG(SM)*PI**4*(SM**2-SM**(-4)*M**2*M0**4-SM**(-4)*M**4*M0
   **2-SM**(-2)*M**2*M0**2-1./2.*M**2-1./2.*M0**2)
   +LG(SM)*LG(M)*PI**4*(2.*SM**(-4)*M**2*M0**4+SM**(-4)*M**4*M0**2+
   SM**(-2)*M**2*M0**2+1./2.*M**2)
   +LG(SM)*LG(M0)*PI**4*(-SM**(-4)*M**2*M0**4+1./2.*M0**2)
   +LG(M)*PI**4*(-3./2.*SM**(-4)*M**4*M0**2-1./6.*SM**(-4)*M**6-1./
   2.*SM**(-2)*M**4-2.*M**2+2.*M**2*EP**(-1))
   +LG(M)*LG(SM)*PI**4*(-SM**(-4)*M**2*M0**4+1./2.*M**2)
   +LG(M)*LG(M)*PI**4*(1./2.*M**2)
   +LG(M)*LG(M0)*PI**4*(SM**(-4)*M**2*M0**4)
   +LG(M0)*PI**4*(-3./2.*SM**(-4)*M**2*M0**4-1./6.*SM**(-4)*M0**6-1
   ./2.*SM**(-2)*M0**4-2.*M0**2+2.*M0**2*EP**(-1))
   +LG(M0)*LG(SM)*PI**4*(2.*SM**(-4)*M**2*M0**4+SM**(-4)*M**4*M0**2
   +SM**(-2)*M**2*M0**2+1./2.*M0**2)
   +LG(M0)*LG(M)*PI**4*(-2.*SM**(-4)*M**2*M0**4-SM**(-4)*M**4*M0**2
   -SM**(-2)*M**2*M0**2)
   +LG(M0)*LG(M0)*PI**4*(1./2.*M0**2)
*fix
BLOCK DIFF{}
B PI
Id,I=i
Id,DM*M**N~=N*M**N/M**2/2+M**N*DM
Al,DM0*M0**N~=N*M0**N/M0**2/2+M0**N*DM0
Al,DSM*SM**N~=N*SM**N/SM**2/2+SM**N*DSM
Id,Adiso,DM*LG(M)*LG(M)=2*LG(M)/M**2+LG(M)*LG(M)*DM
Al,Adiso,DM0*LG(M0)*LG(M0)=2*LG(M0)/M0**2+LG(M0)*LG(M0)*DM0
Al,Adiso,DSM*LG(SM)*LG(SM)=2*LG(SM)/SM**2+LG(SM)*LG(SM)*DSM
Al,DM*LG(M)=1/M**2+LG(M)*DM
Al,DM0*LG(M0)=1/M0**2+LG(M0)*DM0
Al,DSM*LG(SM)=1/SM**2+LG(SM)*DSM
Id,DM*XX=0
Al,DM0*XX=0
Al,DSM*XX=0
Al,XX=1
Id,Commu,LG
Id,EP=0
ENDBLOCK
Z CH1=FX211(M,M0,SM)+DM*FX111(M,M0,SM)*XX
Z CH2=FX112(M,M0,SM)+DSM*FX111(M,M0,SM)*XX
Z CH3=FX211(M0,M,SM)+DM0*FX111(M,M0,SM)*XX
Z CH4=-(1+EP)*FX211(M,M0,SM)+2*M02*DM0*FX211(M,M0,SM)*XX
  -FX112(M,M0,SM)+F2(M)*F2(SM)-MM0SM*DSM*FX211(M,M0,SM)*XX
DIFF{}
Id,M02=M0**2
Al,MM0SM=M**2-M0**2-SM**2
*end

C RO-parameter 17. Differentiating F211.

P stats
F LG
S M,M0,SM
*fix

B PI
Z F311(M,M0,SM)=-1/2*DM*FX211(M,M,M0,SM)*XX
Z F221(M,M0,SM)=-DM0*FX211(M,M,M0,SM)*XX
Z F211(M,M0,SM)=FX211(M,M,M0,SM)
Id,FX211(M~,M~,M0~,SM)=PI**4*(-2/EP**2+(1-2*LG(M))/EP
  -0.5+PI**2/12+LG(M)-LG(M)*LG(M)+0.5*LG(SM,M)*LG(SM,M)
  +(M0**2*SM**2+2*M**2*M0**2+M0**4)/SM**4*LG(SM,M)*LG(SM,M)
  -(M0**2*SM**2+2*M**2*M0**2+M0**4)/SM**4*LG(SM,M)*LG(M0,M)
  -(M**2*SM**2+M0**2*SM**2+4*M**2*M0**2+5/2*M0**4+0.5*M**4)
  /SM**4*LG(SM,M) + (M0**2*SM**2+M**2*M0**2+5/2*M0**4)/SM**4
  *LG(M0,M) - (M**2+M0**2)/SM**2
  - (1/4*M**4+3*M**2*M0**2+9/4*M0**4)/SM**4
  +PI**2/3*(M0**2*SM**2+2*M**2*M0**2+M0**4)/SM**4  )
Id,LG(SM~,M)=LG(SM)-LG(M)
Id,DM*M**N~=N*M**N/M**2/2+M**N*DM
Al,DM0*M0**N~=N*M0**N/M0**2/2+M0**N*DM0
Id,Adiso,DM*LG(M)*LG(M)=2*LG(M)/M**2+LG(M)*LG(M)*DM
Al,Adiso,DM0*LG(M0)*LG(M0)=2*LG(M0)/M0**2+LG(M0)*LG(M0)*DM0
Al,DM*LG(M)=1/M**2+LG(M)*DM
Al,DM0*LG(M0)=1/M0**2+LG(M0)*DM0
Id,DM*XX=0
Al,DM0*XX=0
Al,XX=1
Id,Commu,LG
Keep F311,F221,F211
Punch F311,F221,F211
*next
B PI
Z F411(M,M0,SM)=-1/3*DM*F311(M,M0,SM)*XX
Z F321(M,M0,SM)=-1/2*DM*F221(M,M0,SM)*XX
Id,DM*M**N~=N*M**N/M**2/2+M**N*DM
Al,DM0*M0**N~=N*M0**N/M0**2/2+M0**N*DM0
Id,Adiso,DM*LG(M)*LG(M)=2*LG(M)/M**2+LG(M)*LG(M)*DM
Al,Adiso,DM0*LG(M0)*LG(M0)=2*LG(M0)/M0**2+LG(M0)*LG(M0)*DM0
Al,DM*LG(M)=1/M**2+LG(M)*DM
Al,DM0*LG(M0)=1/M0**2+LG(M0)*DM0
Id,DM*XX=0
Al,DM0*XX=0
Al,XX=1
Id,Commu,LG
Keep F311,F221,F411,F321,F211
Punch F411,F321
*next
B PI
Z F511(M,M0,SM)=-1/4*DM*F411(M,M0,SM)*XX
Z F421(M,M0,SM)=-1/3*DM*F321(M,M0,SM)*XX
Id,DM*M**N~=N*M**N/M**2/2+M**N*DM
Al,DM0*M0**N~=N*M0**N/M0**2/2+M0**N*DM0
Id,Adiso,DM*LG(M)*LG(M)=2*LG(M)/M**2+LG(M)*LG(M)*DM
Al,Adiso,DM0*LG(M0)*LG(M0)=2*LG(M0)/M0**2+LG(M0)*LG(M0)*DM0
Al,DM*LG(M)=1/M**2+LG(M)*DM
Al,DM0*LG(M0)=1/M0**2+LG(M0)*DM0
Id,DM*XX=0
Al,DM0*XX=0
Al,XX=1
Id,Commu,LG
Keep F311,F221,F411,F321,F421,F211,F511
Punch F421,F511
*next
B PI
Z FF211=F211(M,M,SM)
Z FF311=F311(M,M,SM)
Z FF411=F411(M,M,SM)
Z FF511=F511(M,M,SM)
Z FF221=F221(M,M,SM)
Z FF321=F321(M,M,SM)
Z FF421=F421(M,M,SM)
Id,Commu,LG
*end

C RO-parameter 18. Expansion of F211(SM,M1,M2) for large SM.

C A=M1**2/SM**2, B=M2**2/SM**2. LGA=LOG(A), LGB=LG(B).
C S2=PI**2/6. E=EXPANSION PARAMETER, COUNTS ORDER IN A,B. E**7=0.
C THE FORMULA USED IS:
C F(A,B)=-1/2*LOG(A)**2-SP((A-B)/A)
C + FAC1*( SP((B-A)/X1)-SP((A-B)/(1-X1))-SP(1-1/X1)+SP(-X1/(1-X1)) )
C + FAC2*(  SAME, BUT X1 REPLACED BY X2  )
C FAC1=(B-X1)/ROOT, FAC2=(X2-B)/ROOT
C X1=(1+B-A+ROOT)/2, X2=(1+B-A-ROOT)/2.
C ROOT=SQRT((A-B)**2+1-2*(A+B))
C X1,2 SOLUTION OF  X**2+(A-B-1)*X+B=0
C THUS X1*X2=B, (1-X1)*(1-X2)=A, X1+X2=1+B-A.
C NOTE THAT FAC1+FAC2=-1.
C FOR THIS EXPANSION THE EQUATION WAS REWRITTEN AS
C F(A,B)=-1/2*LOG(A)**2-SP((A-B)/A)+SP((A-B)*(1-X2)/A)
C +S2*(1-A-B)/ROOT
C + FAC1*(SP((B-A)*X2/B)-2*SP(-(1-X1)*X2/B)
C -1/2*LOG((1-X1)*X2/B)**2 )
C + FAC2*(-1/2*LOG(1-(B-A)*X1/B)**2-SP((A-B)*(1-X1)/A)
C +2*SP(-X2*(1-X1)/A)+1/2*LOG(X2*(1-X1)/A)**2 )
C THE TERMS LOG(A)**2 AND LOG(B)**2 CANCEL OUT.
C THE EXPRESSIONS BELOW REFER TO THE EXPANSION OF THE
C INDIVIDUAL TERMS, FOR INSTANCE EXP(2) REFERS TO THE
C EXPRESSION CONTAINING S2.
C
C THE FUNCTION F211 IS GIVEN BY
C F211=PI**4*(-2/EP**2+1/EP*(1-2*GA-2*LOG(SM**2)
C       -1/2-PI**2/12+GA-GA**2+(1-2*GA)*LOG(SM**2)
C       -LOG(SM**2)**2-F(A,B) )
C EP=N-4, GA=EULERS CONSTANT. GA MAY BE ABSORBED IN
C A REDIFINITION OF THE UNITS IN THE LOG, WHICH WAS
C ALREADY DONE WITH FACTORS LOG(PI). (READ LOG(PI*SM**2)
C EVERYWHERE).
C THE WORK WAS DIVIDED IN TWO PARTS. PART 1 = COMPUTING THE
C VARIOUS ARGUMENTS OF THE FUNCTIONS TO BE EXPANDED. THIS
C INCLUDED WORKING OUT THE ROOT, ALSO GIVEN HERE. GIVEN X1 AND
C X2 THE OTHER ARGUMENTS ARE COMPUTED ACCORDING TO THE CARDS
C BELOW MADE INACTIVE. PART 2 IS COMPUTING THE EXPRESSIONS.
C PRINT NINPUT
C
C C IN THIS PART X1, X2 ETC ARE COMPUTED TO ORDER E**7. THIS
C C IS NECESSARY TO OBTAIN THE ARGUMENTS OF THE VARIOUS FUNCTIONS
C C TO ORDER E**6.
C
C SCREEN
C N  R
C COMMON XX(0),XX1(0),XX2(0)
C S E=8,A,B
C X X(A)=E**2*(A**2+B**2-2*A*B)-2*E*(A+B)
C *FIX
C Z XX(0)=1.
C *NEXT
C DO K1=1,7
C Z XX('K1')=X(A)*XX('K1'-1)
C B E
C NPRINT XX('K1')
C *NEXT
C ENDDO
C Z WO=1+XX(1)/2-XX(2)/8+XX(3)/16-5*XX(4)/128
C      +7*XX(5)/256-21*XX(6)/1024
C   +33/2048*XX(7)
C Z WOI=1.-XX(1)/2+3*XX(2)/8-5*XX(3)/16+35*XX(4)/128
C       -63*XX(5)/256+231*XX(6)/1024
C      -429/2048*XX(7)
C B E
C KEEP WO,WOI
C *NEXT
C Z X1=0.5+0.5*B*E-0.5*A*E+0.5*WO
C Z X2=0.5+0.5*B*E-0.5*A*E-0.5*WO
C B E
C PUNCH X1,X2
C KEEP WO,WOI,X1,X2
C *NEXT
C B E
C Z OMX1A=1/A/E-X1/A/E
C Z X2B=X2/B/E
C Z BMX2A=B/A-X2/A/E
C PUNCH OMX1A,X2B,BMX2A
C B E
C KEEP X1,X2,WOI
C *NEXT
C S E=7
C Z FAC1=(B*E-X1)*WOI
C Z FAC2=(X2-B*E)*WOI
C B E
C PUNCH FAC1,FAC2
C *END

Common EXP(0),Exp(0)
S LOMX,LGA,LGB

C X X1=1-E*A-A*B*E**2-E**3*A*B**2-E**3*A**2*B
C    +E**4*(-A*B**3-3.*A**2*B**2-A**3*B)
C    +E**5*(-A*B**4-6.*A**2*B**3-6.*A**3*B**2-A**4*B)
C    +E**6*(-A*B**5-10.*A**2*B**4-20.*A**3*B**3-10.*A**4*B**2-A**5*B)
C    +E**7*(-A*B**6-15.*A**2*B**5-50.*A**3*B**4-50.*A**4*B**3-15.*A**
C    5*B**2-A**6*B)
C X X2=E*B+E**2*A*B+E**3*A*B**2+E**3*A**2*B
C    +E**4*(A*B**3+3.*A**2*B**2+A**3*B)
C    +E**5*(A*B**4+6.*A**2*B**3+6.*A**3*B**2+A**4*B)
C    +E**6*(A*B**5+10.*A**2*B**4+20.*A**3*B**3+10.*A**4*B**2+A**5*B)
C    +E**7*(A*B**6+15.*A**2*B**5+50.*A**3*B**4+50.*A**4*B**3+15.*A**5
C    *B**2+A**6*B)
C X OMX1A=1 + E*B
C    +E**2*(A*B+B**2)
C    +E**3*(3.*A*B**2+A**2*B+B**3)
C    +E**4*(6.*A*B**3+6.*A**2*B**2+A**3*B+B**4)
C    +E**5*(10.*A*B**4+20.*A**2*B**3+10.*A**3*B**2+A**4*B+B**5)
C    +E**6*(15.*A*B**5+50.*A**2*B**4+50.*A**3*B**3+15.*A**4*B**2+A**5
C    *B+B**6)
C X X2B=1+E*A
C    +E**2*(A*B+A**2)
C    +E**3*(A*B**2+3.*A**2*B+A**3)
C    +E**4*(A*B**3+6.*A**2*B**2+6.*A**3*B+A**4)
C    +E**5*(A*B**4+10.*A**2*B**3+20.*A**3*B**2+10.*A**4*B+A**5)
C    +E**6*(A*B**5+15.*A**2*B**4+50.*A**3*B**3+50.*A**4*B**2+15.*A**5
C    *B+A**6)
C X BMX2A=-B*E
C    +E**2*(-A*B-B**2)
C    +E**3*(-3.*A*B**2-A**2*B-B**3)
C    +E**4*(-6.*A*B**3-6.*A**2*B**2-A**3*B-B**4)
C    +E**5*(-10.*A*B**4-20.*A**2*B**3-10.*A**3*B**2-A**4*B-B**5)
C    +E**6*(-15.*A*B**5-50.*A**2*B**4-50.*A**3*B**3-15.*A**4*B**2-A**
C    5*B-B**6)
X FAC1=-1-A*B*E**2
   +E**3*(-2.*A*B**2-2.*A**2*B)
   +E**4*(-3.*A*B**3-9.*A**2*B**2-3.*A**3*B)
   +E**5*(-4.*A*B**4-24.*A**2*B**3-24.*A**3*B**2-4.*A**4*B)
   +E**6*(-5.*A*B**5-50.*A**2*B**4-100.*A**3*B**3-50.*A**4*B**2-5.*A
   **5*B)
X FAC2=E**2*A*B
   +E**3*(2.*A*B**2+2.*A**2*B)
   +E**4*(3.*A*B**3+9.*A**2*B**2+3.*A**3*B)
   +E**5*(4.*A*B**4+24.*A**2*B**3+24.*A**3*B**2+4.*A**4*B)
   +E**6*(5.*A*B**5+50.*A**2*B**4+100.*A**3*B**3+50.*A**4*B**2+5.*A
   **5*B)
X ARG1=E*B+A*B*E**2
   +E**3*(A*B**2+A**2*B)
   +E**4*(A*B**3+3.*A**2*B**2+A**3*B)
   +E**5*(A*B**4+6.*A**2*B**3+6.*A**3*B**2+A**4*B)
   +E**6*(A*B**5+10.*A**2*B**4+20.*A**3*B**3+10.*A**4*B**2+A**5*B)
X ARG3=-A*E+E*B
   +E**2*(A*B-A**2)
   +E**3*(A*B**2-A**3)
   +E**4*(A*B**3+2.*A**2*B**2-2.*A**3*B-A**4)
   +E**5*(A*B**4+5.*A**2*B**3-5.*A**4*B-A**5)
   +E**6*(A*B**5+9.*A**2*B**4+10.*A**3*B**3-10.*A**4*B**2-9.*A**5*B
   -A**6)
X ARG4=-A*E
   +E**2*(-A*B-A**2)
   +E**3*(-A*B**2-3.*A**2*B-A**3)
   +E**4*(-A*B**3-6.*A**2*B**2-6.*A**3*B-A**4)
   +E**5*(-A*B**4-10.*A**2*B**3-20.*A**3*B**2-10.*A**4*B-A**5)
   +E**6*(-A*B**5-15.*A**2*B**4-50.*A**3*B**3-50.*A**4*B**2-15.*A**
   5*B-A**6)
X ARG5=E*A+E*B
   +E**2*(3.*A*B+A**2+B**2)
   +E**3*(6.*A*B**2+6.*A**2*B+A**3+B**3)
   +E**4*(10.*A*B**3+20.*A**2*B**2+10.*A**3*B+A**4+B**4)
   +E**5*(15.*A*B**4+50.*A**2*B**3+50.*A**3*B**2+15.*A**4*B+A**5+B*
   *5)
   +E**6*(21.*A*B**5+105.*A**2*B**4+175.*A**3*B**3+105.*A**4*B**2+2
   1.*A**5*B+A**6+B**6)
X ARG6=-E*A+B*E
   +E**2*(-A*B+B**2)
   +E**3*(-A**2*B+B**3)
   +E**4*(2.*A*B**3-2.*A**2*B**2-A**3*B+B**4)
   +E**5*(5.*A*B**4-5.*A**3*B**2-A**4*B+B**5)
   +E**6*(9.*A*B**5+10.*A**2*B**4-10.*A**3*B**3-9.*A**4*B**2-A**5*B
   +B**6)
X ARG8=-B*E
   +E**2*(-A*B-B**2)
   +E**3*(-3.*A*B**2-A**2*B-B**3)
   +E**4*(-6.*A*B**3-6.*A**2*B**2-A**3*B-B**4)
   +E**5*(-10.*A*B**4-20.*A**2*B**3-10.*A**3*B**2-A**4*B-B**5)
   +E**6*(-15.*A*B**5-50.*A**2*B**4-50.*A**3*B**3-15.*A**4*B**2-A**
   5*B-B**6)
S E=7
*fix
C B E
C Z ARG1=X2
C Z ARG3=(B-A)*X2/B
C Z ARG4=1-X2B
C Z ARG5=OMX1A*X2B - 1
C Z ARG6=(B-A)*(1-X1)/A
C Z ARG7=(A-B)*E*OMX1A
C Z ARG8=BMX2A
C Punch ARG1,ARG3,ARG4,ARG5,ARG6,ARG8
C *end
Z SP(1)=-LOMX/X
Z XX2(1)=-ARG1
B E
Nprint SP,XX2
Keep SP,XX2
*next
DO K1=2,6
P input
Z SP('K1')=DIFX*SP('K1'-1)*YY/'K1'
Z XX2('K1')=-XX2('K1'-1)*ARG1
Id,DIFX*LOMX=-1/OMX+LOMX*DIFX
Id,DIFX*OMX**N~=-N*OMX**N/OMX+OMX**N*DIFX
Id,DIFX*X**N~=N*X**N/X+X**N*DIFX
Id,DIFX*YY=0
Al,YY=1
Id,X**N~*OMX**-1=DS(J1,1,-N,(X**-J1))+1/OMX
B E
Nprint SP,XX2
Keep SP,XX2
*next
ENDDO
DO K2=1,6
P input
Z SP('K2')=SP('K2')*X**'K2'
ENDDO
Id,X**N~*OMX**M~=XOMX**-M*X**N*X**M
Id,X=(A-B)/A
Al,XOMX=(A-B)/B
Id,LOMX=LGB-LGA
B LGA,LGB
Keep SP,XX2
Nprint SP
*next
B E,LGA,LGB
Z EXP(1)=DS(J3,1,6,(SP(J3)*XX2(J3)) )
*next
B E,S2
Z EXP(2)=S2*(FAC2-FAC1)
*next
B E
Z TOT(3)=0
Z TOT(4)=0
Z TOT(7)=0
Z TOT(8)=0
Z SP(3)=ARG3
Z SP(4)=ARG4
Z SP(7)=-ARG6
Z SP(8)=ARG8
Keep TOT,SP
Nprint TOT,SP
*next
DO K3=2,6
B E
Z TOT(3)=TOT(3)+SP(3)
Z TOT(4)=TOT(4)+SP(4)
Z TOT(7)=TOT(7)+SP(7)
Z TOT(8)=TOT(8)+SP(8)
Z SP(3)=SP(3)*ARG3*('K3'-1)**2/'K3'**2
Z SP(4)=SP(4)*ARG4*('K3'-1)**2/'K3'**2
Z SP(7)=-SP(7)*ARG6*('K3'-1)**2/'K3'**2
Z SP(8)=SP(8)*ARG8*('K3'-1)**2/'K3'**2
Keep TOT,SP
Nprint TOT,SP
*next
ENDDO
B E
Z EXP(3)=FAC1*(TOT(3)+SP(3))
Z EXP(4)=-2*FAC1*(TOT(4)+SP(4))
Z EXP(7)=-FAC2*(TOT(7)+SP(7))
Z EXP(8)=2*FAC2*(TOT(8)+SP(8))
*next
Z Exp(3)=EXP(3)
Z Exp(4)=EXP(4)
Z Exp(7)=EXP(7)
Delete EXP(3),EXP(4),EXP(7)
*next
B E,LGA,LGB
Z XX(5)=ARG5
Z XX(6)=ARG6
Z TOT(5)=0
Z TOT(6)=0
Keep XX,TOT
Nprint XX,TOT
*next
DO K5=2,6
Z TOT(5)=TOT(5)+XX(5)
Z TOT(6)=TOT(6)+XX(6)
Z XX(5)=-XX(5)*ARG5*('K5'-1)/'K5'
Z XX(6)=-XX(6)*ARG6*('K5'-1)/'K5'
B E
Keep TOT,XX
Nprint TOT,XX
*next
ENDDO
B E
Z TOT(5)=TOT(5)+XX(5)
Z TOT(6)=TOT(6)+XX(6)
Keep TOT
Nprint TOT
*next
Z TOT(15)=TOT(5)*TOT(5)
Z TOT(16)=TOT(6)*TOT(6)
Keep TOT
Nprint TOT
B E
*next
Z EXP(5)=-0.5*FAC1*(2*LGA*TOT(5)+TOT(15))
Z EXP(6)=-0.5*FAC2*(-2*LGA*LGB+2*ABLG*TOT(6)+TOT(16) )
Z EXP(9)=+0.5*FAC2*(2*LGB*TOT(5)+TOT(15))
Id,ABLG=LGA-LGB
B E,LGA,LGB
*next
Z EXP(3)=Exp(3)
Z EXP(4)=Exp(4)
Z EXP(7)=Exp(7)
Delete Exp(3),Exp(4),Exp(7)
*next
B E,LGA,LGB,S2
Z TOTAL=DS(J0,1,9,(EXP(J0)))
P outp
*yep
C Id,Numer,E,1.
Id,E=1
B S2,LGA,LGB
*end

C RO-parameter 19. Higher orders of F211(M,M0,SM) expansion for large SM.

C THE HIGHER ORDERS ARE MADE SUCH THAT THE RELATION
C -(N-3)*F211-2*M0**2*F221-F112+F2(M)*F2(M)+(M**2-M0**2-SM**2)*F212=0
C IS SATISFIED. START WITH THE COEFFICIENT OF LGA*LGB, ETC.
F LG
S M,M0,SM,LGA,LGB
C THIS IS F211/PI**4
X F211=-1./2.-A-3.*A*B-1./4.*A**2-B-9./4.*B**2
   -47/18*B**3-9*B**2*A-11/2*B*A**2-1/9*A**3
    -401/144*B**4-20*B**3*A-107/4*B**2*A**2-74/9*B*A**3-1/16*A**4
    -5197/1800*B**5-2296/63*B**4*A-177/2*B**3*A**2-569/9*B**2*A**3
     -797/72*B*A**4-1/25*A**5
   +LGA*(1.+A+3.*A*B+1./2.*A**2
    +5*B**2*A+7*B*A**2+1/3*A**3
    +7*B**3*A+51/2*B**2*A**2+35/3*B*A**3+1/4*A**4
    +9*B**4*A+62*B**3*A**2+224/3*B**2*A**3
     +101/6*B*A**4+1/5*A**5 )
   +LGA*LGB*(2.*A*B+B+B**2
    +B**3+6*B**2*A+3*B*A**2
    +B**4+12*B**3*A+18*B**2*A**2+4*B*A**3
    +B**5+20*B**4*A+60*B**3*A**2+40*B**2*A**3
     +5*B*A**4 )
   -1./2.*LGA**2
   +LGB*(A*B+B+5./2.*B**2
  +10/3*B**3+8*B**2*A+B*A**2
    +47/12*B**4+23*B**3*A+33/2*B**2*A**2+B*A**3
    +131/30*B**5+142/3*B**4*A+82*B**3*A**2+28*B**2*A**3
     +B*A**4 )
   +PI**2*(1./12.+2./3.*A*B+1./3.*B+1./3.*B**2
    +1/3*B**3+2*B**2*A+B*A**2
    +1/3*B**4+4*B**3*A+6*B**2*A**2+4/3*B*A**3
   +1/3*B**5+20/3*B**4*A+20*B**3*A**2+40/3*B**2*A**3
   +5/3*B*A**4 )
   -2.*EP**(-2)
   +EP**(-1)
   -2.*EP**(-1)*LGA
   +LG(SM)
   -2.*LG(SM)*LGA
   -2.*LG(SM)*EP**(-1)
   -LG(SM)*LG(SM)
C THIS IS F2(M)*F2(SM)/PI**4
X F22=-1./2.*LGA**2
   -1./6.*PI**2
   -4.*EP**(-2)
   -2.*EP**(-1)*LGA
   -2.*LG(SM)*LGA
   -4.*LG(SM)*EP**(-1)
   -2.*LG(SM)*LG(SM)
X FFF(A,B)=-A-A*B-3.*A*B**2-11./2.*A*B**3-74./9.*A*B**4-797./72.*A*B*
   *5-1./4.*A**2-3.*A**2*B-49./4.*A**2*B**2-35.*A**2*B**3-2851./36.
   *A**2*B**4-1./9.*A**3-11./2.*A**3*B-35.*A**3*B**2-2531./18.*A**3
   *B**3-1./16.*A**4-74./9.*A**4*B-2851./36.*A**4*B**2-1./25.*A**5-
   797./72.*A**5*B-1./36.*A**6-B-1./4.*B**2-1./9.*B**3-1./16.*B**4-
   1./25.*B**5-1./36.*B**6
   +LGA*(A+A*B+A*B**2+A*B**3+A*B**4+A*B**5+1./2.*A**2+4.*A**2*B+21.
   /2.*A**2*B**2+20.*A**2*B**3+65./2.*A**2*B**4+1./3.*A**3+8.*A**3*
   B+40.*A**3*B**2+370./3.*A**3*B**3+1./4.*A**4+38./3.*A**4*B+310./
   3.*A**4*B**2+1./5.*A**5+107./6.*A**5*B+1./6.*A**6)
   +LGA*LGB*(A*B+2.*A*B**2+3.*A*B**3+4.*A*B**4+5.*A*B**5+2.*A**2*B+
   9.*A**2*B**2+24.*A**2*B**3+50.*A**2*B**4+3.*A**3*B+24.*A**3*B**2
   +100.*A**3*B**3+4.*A**4*B+50.*A**4*B**2+5.*A**5*B)
   +LGB*(A*B+4.*A*B**2+8.*A*B**3+38./3.*A*B**4+107./6.*A*B**5+A**2*
   B+21./2.*A**2*B**2+40.*A**2*B**3+310./3.*A**2*B**4+A**3*B+20.*A*
   *3*B**2+370./3.*A**3*B**3+A**4*B+65./2.*A**4*B**2+A**5*B+B+1./2.
   *B**2+1./3.*B**3+1./4.*B**4+1./5.*B**5+1./6.*B**6)
   +S2*(1.+2.*A*B+4.*A*B**2+6.*A*B**3+8.*A*B**4+10.*A*B**5+4.*A**2*
   B+18.*A**2*B**2+48.*A**2*B**3+100.*A**2*B**4+6.*A**3*B+48.*A**3*
   B**2+200.*A**3*B**3+8.*A**4*B+100.*A**4*B**2+10.*A**5*B)+0.
*fix
B EP,LGA,LGB,PI,SM
Z F112=-2/EP**2+(1-2*LG(SM))/EP-1/2-PI**2/12+LG(SM)-LG(SM)*LG(SM)
       -FFF(A,B)
Z F221=-DM0*F211*XX
Z F212=DM*FFF(A,B)*XX
Z FF211=F211
Id,DM=DFA/SM**2
Al,DM0=DFB/SM**2
Al,EP=0
Id,DFB*B**N~=N*B**N/B+B**N*DFB
Al,DFA*A**N~=N*A**N/A+A**N*DFA
Id,DFB*LGB**2=2*LGB/B+LGB**2*DFB
Al,DFA*LGA**2=2*LGA/A+LGA**2*DFA
Al,DFB*LGB=1/B+LGB*DFB
Al,DFA*LGA=1/A+LGA*DFA
Id,DFB*XX=0
Al,DFA*XX=0
Al,XX=1
Id,Multi,M**2=A*SM**2
Al,Multi,M0**2=B*SM**2
Id,LG(M)=LGA+LG(SM)
Al,LG(M0)=LGB+LG(SM)
Id,Commu,LG
Id,S2=PI**2/6
Keep F112,F221,F212
*next
B EP,LGA,LGB,PI,SM
Z CH1=-(1+EP)*F211-2*M0**2*F221-F112+F22+(M**2-M0**2-SM**2)*F212
Id,Multi,M**2=A*SM**2
Al,Multi,M0**2=B*SM**2
Id,EP=0
Id,Commu,LG
*end

C RO-parameter 20. Expansion of F211(SM,SM,M) for large SM.

C S X=13,B=7
C *FIX
C Z XX(1)=X
C KEEP XX
C *NEXT
C DO K2=2,12
C Z XX(K2)=XX(K2-1)*X
C ID,X**2=B*X-B
C KEEP XX
C PUNCH XX(K2)
C *NEXT
C ENDDO
C *END

Common Exp,Expp
S B=7,LGB,ROOT,FACT
S X1=13,X2=13
X FB=1+B+B**2+B**3+B**4*B**5+B**6
D POW(N,X)=X,
     (-B+B*X),
     (-B*X-B**2+B**2*X),
     (+B**2-2.*B**2*X-B**3+B**3*X),
     (+B**2*X+2.*B**3-3.*B**3*X-B**4+B**4*X),
     (-B**3+3.*B**3*X+3.*B**4-4.*B**4*X-B**5+B**5*X),
     (-B**3*X-3.*B**4+6.*B**4*X+4.*B**5-5.*B**5*X-B**6+B**6*X),
     (+B**4-4.*B**4*X-6.*B**5+10.*B**5*X+5.*B**6-6.*B**6*X),
     (+B**4*X+4.*B**5-10.*B**5*X-10.*B**6+15.*B**6*X),
     (-B**5+5.*B**5*X+10.*B**6-20.*B**6*X),
     (-B**5*X-5.*B**6+15.*B**6*X),
     (+B**6-6.*B**6*X),
     B**6*X,0.
*fix
Z TOT=0.
Z TOTP=0.
Z SPE=-X1*FB
Z SPEP=X2-X2**2
Keep TOT,SPE,TOTP,SPEP
Nprint TOT,SPE,TOTP,SPEP
*next
DO K1=2,12
Z TOT=TOT+SPE
Z TOTP=TOTP+SPEP
Z SPE=-SPE*X1*FB*('K1'-1)**2/'K1'**2
Z SPEP=SPEP*(X2-X2**2)*('K1'-1)**2/'K1'**2
Nprint TOT,SPE,TOTP,SPEP
Keep TOT,SPE,TOTP,SPEP
*next
ENDDO
Z TOT=TOT+SPE
Z TOTP=TOTP+SPEP
Nprint TOT,TOTP
Keep TOT,TOTP
*next
N 20,R20
B LGB,ROOT,FACT
X SP(X)=X+X**2/4+X**3/9+X**4/16+X**5/25+X**6/36+X**7/49
     +X**8/64+X**9/81+X**10/100+X**11/121+X**12/144
X LGP(X)=-X-X**2/2-X**3/3-X**4/4-X**5/5-X**6/6-X**7/7
     -X**8/8-X**9/9-X**10/10-X**11/11-X**12/12
C TOT=SPENCE(-X1/(1-B)), TOTP=SPENCE(X2-X2**2).
C POWERS OF X1 AND X2 HAVE BEEN COMPUTED USING X**2=B*X-B.
Z EXP=FACT*(-TOT+TOTP+2*SP(X2)-S2
  +(LGP(B)+LGP(X2))*(LGB+LGP(X2))
  +0.5*LGP(X1)*LGP(X1)-0.5*LGP(B)*LGP(B) )
  +SP(B)+LGB*LGP(B)-S2
*yep
Id,X1**N~=POW(N,X1)
Al,X2**N~=POW(N,X2)
*yep
Id,X1=0.5*B+0.5*ROOT
Al,X2=0.5*B-0.5*ROOT
Al,FACT=B/ROOT-1
Id,ROOT=0.
Al,ROOT**-1=0
Keep EXP
Punch EXP
*next
B EP,LGB,PI
F LG
C COMPUTE NOW F211(SM,SM,M), WITH B=M**2/SM**2.
Z F211=PI**4*(-2/EP**2+(1-2*GA-2*LG(SM))/EP
   -1/2-PI**2/12+GA-GA**2+(1-2*GA)*LG(SM)-LG(SM)*LG(SM)
   -EXP )
Z Exp=EXP
C GA=EULERS CONSTANT, CAN BE ABSORBED INTO LOG DEFINITION.
Id,GA=0
Keep F211
*next
Z Expp=F211
*begin
Write Exp
Write Expp
*end
